-- 战斗BUFF详情
Lua_FightBuffDetailsWindow = class("Lua_FightBuffDetailsWindow", Lua_Window);
function Lua_FightBuffDetailsWindow:ctor(p)
	self:superCall("ctor");

	self.w = 668;
	self.h = 787;
	self.windowName = "Lua_FightBuffDetailsWindow";
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "xui_common_tips_001";
	self.winBgPosX = 0;
	self.winBgPosY = 42.5;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -420;
end

function Lua_FightBuffDetailsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 630, 740, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(0, 42.5, 0);

	self:addLuaEvent("refresh_fight_buff", self, self.updateShowInfo);
end

function Lua_FightBuffDetailsWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_FightBuffDetailsWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateShowInfo();
end

function Lua_FightBuffDetailsWindow:updateShowInfo()
	self.dragContainer:clearList();
	if self.showData == nil then
		return;
	end

	local thing = DataCenter.thingData:getThingPlayer(self.showData.sceneId, self.showData.recordId, self.showData.playerId);
	if thing == nil or thing.data == nil then
		return;
	end

	local count = thing.data.buffCount;
	if count > 0 then
		local fightPlayer = DataCenter.fightData:getFightPlayerById(self.showData.recordId);
		count = count - 1;
		local dic = {};
		for i = 0, count do
			local buffId = thing.data:getBuffIdByIdx(i);
			local buffData = Lua_BuffConfigData.getConfigData(buffId);
			if buffData and not strIsNullOrEmpty(buffData.atlas) and not strIsNullOrEmpty(buffData.sprite) then
				local leftRound = thing.data:getBuffFinishRoundByIdx(i) - fightPlayer.curRound;
				if dic[buffData.effectNum] == nil then
					local vo = Lua_BuffVo.new();
					vo.id = buffId;
					vo.atlas = buffData.atlas;
					vo.sprite = buffData.sprite;
					vo.sortWeight = buffData.sort;
					vo.overlayNum = thing.data:getBuffOverlayNumByIdx(i);
					vo.leftRound = leftRound;
					dic[buffData.effectNum] = vo;
				else
					if buffData.sort > dic[buffData.effectNum].sortWeight then
						dic[buffData.effectNum].sortWeight = buffData.sort;
					end

					dic[buffData.effectNum].overlayNum = dic[buffData.effectNum].overlayNum + thing.data:getBuffOverlayNumByIdx(i);
					if buffData.superposeLimit > dic[buffData.effectNum].overlayNum then
						dic[buffData.effectNum].overlayNum = buffData.superposeLimit;
					end
					
					if leftRound > dic[buffData.effectNum].leftRound then
						dic[buffData.effectNum].leftRound = leftRound;
					end
				end
			end
		end

		local arr = Array();
		for k,v in pairs(dic) do
			arr:add(v);
		end
		arr:sort("sortWeight", false);

		for i = 1, arr:getSize() do
			self.dragContainer:addSubContainer(Lua_FightBuffDetailsItem, arr[i], false);
		end
		self.dragContainer:updateChildPos();
	end
end




















Lua_FightBuffDetailsItem = class("Lua_FightBuffDetailsItem", Lua_DragContainerItem);
function Lua_FightBuffDetailsItem:ctor(p)
	self:superCall("ctor", p, "FightBuffDetailsItem_skin");
end

function Lua_FightBuffDetailsItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FightBuffDetailsItem:dispose()
	self:superCall("dispose");
end

function Lua_FightBuffDetailsItem:setData(data)
	self.icon:setAltas(data.atlas, data.sprite);
	local buffData = Lua_BuffConfigData.getConfigData(data.id);
	self.nameText.text = buffData.name.."*"..data.overlayNum;
	if data.leftRound > 0 then
		self.timeText.text = LanUtil.formateStr(302007, tostring(data.leftRound));
	else
		self.timeText:setLangValue(302014);
	end
	self.desText.text = buffData.des;
	self.desText:resetSize();
	self.line:setLocation(0, -59.5 - self.desText.height - 10, 0);
end

function Lua_FightBuffDetailsItem:getWidth()
    return 630;
end

function Lua_FightBuffDetailsItem:getHeight()
	return Mathf.Abs(-59.5 - self.desText.height) + 10;
end