Lua_FightInfoItem = class("Lua_FightInfoItem", Lua_DisplayObject)
function Lua_FightInfoItem:ctor(p)
	self:superCall("ctor", p, "FightInfoItem_skin")
end

function Lua_FightInfoItem:buildShowItem()
	self:superCall("buildShowItem")

	self.leftForce = Lua_NumberImage.new(self.content)
	self.leftForce:setLocation(-240, -30, 0)
	self.leftForce.pivot = 1
	self.leftForce.numOffsetX = -4
	self.leftForce.numAtlas = "number"
	self.leftForce.preStr = "xui_zl1_number_0"

	self.rightForce = Lua_NumberImage.new(self.content)
	self.rightForce:setLocation(275.8, -30, 0)
	self.rightForce.pivot = -1
	self.rightForce.numOffsetX = -4
	self.rightForce.numAtlas = "number"
	self.rightForce.preStr = "xui_zl1_number_0"

	self.icon_1:addClickFuntion(self, self.checkAttacker);
	self.icon_2:addClickFuntion(self, self.checkDefender);
end

function Lua_FightInfoItem:dispose()
	if self.leftForce then
		self.leftForce:dispose()
		self.leftForce = nil
	end
	if self.rightForce then
		self.rightForce:dispose()
		self.rightForce = nil
	end
	self.recordVo = nil
	self:superCall("dispose")
end

function Lua_FightInfoItem:setName(leftName, rightName)
	self.leftName.text = leftName
	self.rightName.text = rightName
end

-- 连携
-- function Lua_FightInfoItem:setData(recordVo)
-- 	self.recordVo = recordVo

-- 	self.icon_1:setAltas("hero_embattle", "xui_bz_widget_"..24 + recordVo.attackerConnNum)
-- 	self.connCount_1.text = recordVo.attackerConnNum

-- 	self.icon_2:setAltas("hero_embattle", "xui_bz_widget_"..24 + recordVo.defenderConnNum)
-- 	self.connCount_2.text = recordVo.defenderConnNum
-- end

-- 光环属性
function Lua_FightInfoItem:setData(recordVo)
	self.attackAureoleId = recordVo.attackAureoleId;
	config = DataCenter.heroLineupUtil:getAureoleConfig(self.attackAureoleId);
	if config == nil then
		self.icon_1:setAltas("hero_embattle", "xui_bz_widget_24");
	else
		self.icon_1:setAltas(config.atlas, config.sprite);
	end

	self.defendAureoleId = recordVo.defendAureoleId;
	config = DataCenter.heroLineupUtil:getAureoleConfig(self.defendAureoleId);
	if config == nil then
		self.icon_2:setAltas("hero_embattle", "xui_bz_widget_24");
	else
		self.icon_2:setAltas(config.atlas, config.sprite);
	end
end

function Lua_FightInfoItem:setForce(leftForce, rightForce)
	leftForce = leftForce or 0;
	leftForce = tonumber(leftForce);
	if leftForce > 0 then
		self.leftForce.num = leftForce
		self.leftForceIcon:setEnable(true)
	else
		self.leftForce.num = nil
		self.leftForceIcon:setEnable(false)
	end

	rightForce = rightForce or 0;
	rightForce = tonumber(rightForce);
	if rightForce > 0 then
		self.rightForce.num = rightForce
		self.rightForceIcon:setEnable(true)
		self.rightForceIcon:setLocation(275.8 - self.rightForce.totalWidth - 20, -30, 0)
	else
		self.rightForce.num = nil
		self.rightForceIcon:setEnable(false)
	end
end

function Lua_FightInfoItem:checkAttacker(go)
	-- if self.recordVo == nil or self.recordVo.attackerConnArr == nil or self.recordVo.attackerConnArr:getSize() <= 0 then
	-- 	OperateAlert.showLangValue(126066)
	-- 	return
	-- end
	-- Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, self.recordVo.attackerConnArr)
	Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.attackAureoleId);
end

function Lua_FightInfoItem:checkDefender(go)
	-- if self.recordVo == nil or self.recordVo.defenderConnArr == nil or self.recordVo.defenderConnArr:getSize() <= 0 then
	-- 	OperateAlert.showLangValue(126066)
	-- 	return
	-- end
	-- Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, self.recordVo.defenderConnArr)
	Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.defendAureoleId);
end