-- 战斗
checkRequire("Lua_FightInfoItem")
checkRequire("Lua_FightIntoEffShowPanel"); -- 开始特效
checkRequire("Lua_FightBossHurtPanel"); -- BOSS伤害
checkRequire("Lua_FightBossChallengeHurtPanel");
checkRequire("Lua_FightStarPanel"); -- 战斗星级
checkRequire("Lua_FightGradePanel"); -- 战斗评级
checkRequire("Lua_FightTeamUpPanel"); -- 战斗组队
checkRequire("Lua_FightDetachmentPanel"); -- 战斗分队
-- checkRequire("Lua_FightTurnOnPromptsItem"); -- 开启提示
checkRequire("Lua_KunXuHolyLandStartFightPanel"); -- 昆墟圣地开始界面
checkRequire("Lua_FightArtifactPanel"); -- 神器释放技能
checkRequire("Lua_FightBossInfoPanel"); -- BOSS信息
checkRequire("Lua_FightPlotPanel"); -- 剧情
checkRequire("Lua_FihgtUnitStatePanel"); -- 分队状态
checkRequire("Lua_FightBeastsPanel"); -- 异兽释放技能
Lua_FightMainWindow = class("Lua_FightMainWindow", Lua_Window);
function Lua_FightMainWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_FightMainWindow";
	self.skinName = "FightMainWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
end

function Lua_FightMainWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("FIGHTPLAY_ROTATION_CHANGE", self, self.showStartEff);
	self:addLuaEvent("fight_formation_change", self, self.onFormationChange);
	self:addLuaEvent("fightPlay_speed_change", self, self.onSpeedChange);
	self:addLuaEvent("fight_enter_scene", self, self.onUpdateRecordInfo);
	self:addLuaEvent("fight_execute_action", self, self.onUpdateExecuteActionInfo);
	self:addLuaEvent("skillAttackHurtUpdate", self, self.onSkillHurtUpdate);
	self:addLuaEvent("fight_roleSkill_update", self, self.onUpdateRoleSkill);
	self:addLuaEvent("FIGHT_BEAST_SKILL_UPDATE", self, self.onUpdateBeastSkill);
	self:addLuaEvent("fight_plotEvent_update", self, self.onServerPlotUpdate);
	self:addLuaEvent("FIGHT_BOSS_INFO_UPDATE", self, self.onUpdateBossInfo);
	self:addLuaEvent("FIGHT_BOSS_BUFF_UPDATE", self, self.onUpdateBossBuff);
end

function Lua_FightMainWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.curAction = 1; -- 当前行动
	self.curRound = 1; -- 当前回合
	self.curRotation = 1; -- 当前轮次

	self:createGradePanel();
	self:createTeamUpPanel();

	self.rotationObj:SetActive(false);
	self.roundObj:SetActive(false);
	self.hurtObj:SetActive(false);
	self.skillObj_1:SetActive(false);
	self.skillObj_2:SetActive(false);

	LuaUtil.setObjPos(self.maskObj, 0, GlobalVar.screenOffsetTopH, 0);
	self.maskObj:SetActive(false);
	self.pauseMask:SetDimensions(self.width, MainWinDefine.V_height);
	self.pauseMask:addClickFuntion(self, self.onBlackMaskClick);

	self.infoItem = Lua_FightInfoItem.new(self.showObject)
	self.infoItem:setRectAnchor(1)
	self.infoItem:setLocation(0, -39, 0)

	-- 关闭布阵界面
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_InfinityHallIndividualWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_InfinityHallTeamWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TowerLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_StarTrialLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_NewHeroActStoryLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_PeakDuelMatchWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_EquipCopyLineupWindow", Lua_WinParam.ACTION_CLOSE);	--关闭寂灭岛布阵界面
	Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭寂灭岛组队界面
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLineupWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地布阵界面
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地战斗阵容准备界面
	Lua_WindowUtil.openWin("Lua_LeagueDuelLineupWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭公会对抗抢夺布阵界面
	Lua_WindowUtil.openWin("Lua_BossOrHeroChallengeLineupWindow", Lua_WinParam.ACTION_CLOSE); -- BOSS挑战或者英雄挑战布阵
	Lua_WindowUtil.openWin("Lua_PeakDuelLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TimeSpaceRaceLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FormTeamCompetitionTeamAdjustWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_EndlessLevelLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_WildStageLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_WildLodeAttackLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_WildLodeInfoWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_WildLodeRecommWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_AllianceFightLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_AllianceFightEnemyDefenseInfoWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_GodSeaPeakFightWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ChaosCopyLineupWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_FightMainWindow:dispose()
	if self.roundNumTxt then
		TweenUtil.getInstance():stop(self.roundNumTxt.mainContent);
	end
	if self.skillObj_1 then
		TweenUtil.getInstance():stop(self.skillObj_1);
	end
	if self.skillObj_2 then
		TweenUtil.getInstance():stop(self.skillObj_2);
	end
	if self.hurtObj then
		TweenUtil.getInstance():stop(self.hurtObj);
	end
	
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	Lua_CommonUtil.removeTimer(self, self.onOverStartEffShow);
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	-- Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_InfinityHallBuffWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_FightOverallBuffWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_FightBuffDetailsWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_FightQueueWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	Lua_WindowUtil.openWin("Lua_HeroGridViewWindow", Lua_WinParam.ACTION_CLOSE, nil, true);

	if self.startEffPanel ~= nil then -- 移除开始动画
		self.startEffPanel:dispose();
		self.startEffPanel = nil;
	end

	if self.infoItem then
		self.infoItem:dispose()
		self.infoItem = nil
	end

	if self.artifactPanel then
		self.artifactPanel:dispose()
		self.artifactPanel = nil
	end
	if self.beastsPanel then
		self.beastsPanel:dispose();
		self.beastsPanel = nil;
	end

	self:clearPanel()
	if self.operateList then
		self.operateList:dispose()
		self.operateList:clear()
		self.operateList = nil
	end

	if self.speedTips then
		self.speedTips:dispose()
		self.speedTips = nil

		self.speedEff:dispose();
		self.speedEff = nil;
	end
	if self.hangTips then
		self.hangTips:dispose()
		self.hangTips = nil

		self.hangEff:dispose();
		self.hangEff = nil;
	end

	if self.bossInfoPanel then
		self.bossInfoPanel:dispose()
		self.bossInfoPanel = nil
	end

	if self.skillEff then
		self.skillEff:dispose();
		self.skillEff = nil;
	end

	if self.desBg ~= nil then
		self.desBg:dispose();
		self.desBg = nil;
	end
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end

	self:removeSkillStar();

	self._recordVo = nil;
	self:updateFightPlot(0);
	self:superCall("dispose");
end

function Lua_FightMainWindow:onScreenResize()
	self:superCall("onScreenResize");
	LuaUtil.setObjPos(self.maskObj, 0, GlobalVar.screenOffsetTopH, 0);
	self.pauseMask:SetDimensions(self.width, MainWinDefine.V_height);
end

function Lua_FightMainWindow:showWin(param)
	self:superCall("showWin", param);
	print("curShowFight : ", param)
	if self.isDispose_3 == true then
		return;
	end

	-- 重播数据下发后，移除旧ID
	local removeFightId = DataCenter.fightData.removeFightId
	if removeFightId and param ~= removeFightId then
		DataCenter.fightData:removeFight(removeFightId, false)
		DataCenter.fightData.removeFightId = nil
	end

	self:init()
	self:updateFightPlot(0);
	self:onUpdateRecordInfo(param);
	self:showStartEff(1);
	self:onShowEndlessLevelSkipTips();

	-- 结算界面直接挑战下一层/下一关，关闭结算界面
	local config = Lua_FightTemplateConfigData.getConfigData(self.templateId)
	if config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then
		Lua_WindowUtil.openWin("Lua_MainLineFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == 1012 or self.templateId == 1038 then
		Lua_WindowUtil.openWin("Lua_ExpeditionChallengeWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == 1004 then
		Lua_WindowUtil.openWin("Lua_NormalTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == 1007 then
		Lua_WindowUtil.openWin("Lua_WindTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == 1008 then
		Lua_WindowUtil.openWin("Lua_FireTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == 1009 then
		Lua_WindowUtil.openWin("Lua_WaterTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == 1010 then
		Lua_WindowUtil.openWin("Lua_SoilTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVE then
		Lua_WindowUtil.openWin("Lua_WildStageFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOS_COPY then
		Lua_WindowUtil.openWin("Lua_ChaosCopyFightWinResultWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	end
end

function Lua_FightMainWindow:onShowEndlessLevelSkipTips()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL and DataCenter.endlessLevelData.isNeedSkip then
		DataCenter.endlessLevelData.isNeedSkip = false;
		Lua_WindowUtil.openWin("Lua_EndlessLevelSkipTipsWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_FightMainWindow:init()
	-- 防止多次点击跳过按钮、挂起按钮
	self.isPressSkip = nil;
	self.isPressHang = nil;

	TweenUtil.getInstance():stop(self.roundNumTxt.mainContent);
	TweenUtil.getInstance():stop(self.skillObj_1);
	self.skillObj_1:SetActive(false);
	TweenUtil.getInstance():stop(self.skillObj_2);
	self.skillObj_2:SetActive(false);
	TweenUtil.getInstance():stop(self.hurtObj);
	self.hurtObj:SetActive(false);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	if self.bossInfoPanel then
		self.bossInfoPanel:setEnable(false)
	end
end

function Lua_FightMainWindow:onUpdateRecordInfo(rid)
	if self._recordId ~= rid then
		self._recordId = rid;
		self._recordVo = DataCenter.fightData:getRecordVoById(rid);
		if self._recordVo == nil then
			return;
		end
		self._maxRotation = self._recordVo.maxRotation;
		self._maxRound = self._recordVo.maxRound;

		if self.templateId ~= self._recordVo.templateId then
			self:clearPanel()
		end
		self.templateId = self._recordVo.templateId
		self:createPanel()
		self:checkOperate()

		self:onSkillHurtUpdate(0)
		self:updateRoleInfo();
		local player = DataCenter.fightData:getFightPlayerById(self._recordId);
		if player ~= nil then
			self.curSession = player.curSession;
			self.curRotation = player.curRotation;
			self.curRound = player.curRound;
			self.curAction = player.curAction;
			self:onFormationChange();
			self:onUpdateRoleSkill();
			self:onUpdateBeastSkill();
			self:onUpdateExecuteActionInfo(player.curPlayActionInfo);
			if self._recordVo.bPlayedStartEff == true and self.startEffPanel ~= nil then
				self:updateFightPlot(self._recordVo.plotId);
			end
		end
		
		if self.teamUpPanel ~= nil then
			self.teamUpPanel:setData(self._recordId);
		end
	end
end

function Lua_FightMainWindow:updateRoleInfo()
	self.infoItem:setName(self._recordVo.attacker.name, self._recordVo.defender.name)
	local attackerForce = 0
	local defenderForce = 0
	local lineup = self._recordVo.attackerLineup
	if lineup then
		attackerForce = lineup.force
	end
	lineup = self._recordVo.defenderLineup
	if lineup then
		defenderForce = lineup.force
	end
	self.infoItem:setForce(attackerForce, defenderForce)
end

function Lua_FightMainWindow:onFormationChange()
	self.infoItem:setData(self._recordVo)
end

function Lua_FightMainWindow:onUpdateExecuteActionInfo(info)
	if self.fightPlotPanel ~= nil then
		self.fightPlotPanel:frameScript();
		local player = DataCenter.fightData:getFightPlayerById(self._recordId);
		if player.bStopPlay then
			return;
		end
	end

	if info == nil then
		return;
	end

	if self.desTxt ~= nil then
		self.desTxt.text = LanUtil.formateStr(779000, self._recordVo.endlessLevelScore);
	end

	local bRoundChange = (info.round > self.curRound);
	self.curSession = info.session;
	self.curRotation = info.rotation;
	self.curRound = info.round;

	if self._maxRotation > 0 then
		self.rotationTxt.text = LanUtil.formateStr(302009, tostring(self.curRotation), tostring(self._maxRotation));
	else
		self.rotationTxt.text = LanUtil.formateStr(302000, tostring(self.curRotation));
	end

	local str
	if info.round > 9 then
		str = "   "
	else
		str = "  "
	end
	if self._maxRound > 0 then
		self.roundTxt.text = LanUtil.formateStr(302001, str, tostring(self._maxRound));
		if self._maxRound > 9 then
			self.roundNumTxt:setLocation(-30, -60, 0)
		else
			self.roundNumTxt:setLocation(-22, -60, 0)
		end
	else
		self.roundTxt.text = LanUtil.formateStr(302002, str);
	end
	self.roundNumTxt.text = self.curRound;

	if bRoundChange then
		TweenUtil.getInstance():stop(self.roundNumTxt.mainContent);
		TweenUtil.getInstance():addTweenTargetScale(self.roundNumTxt.mainContent, 0.2, 0, 1.5, 1.5, 1.5);
		TweenUtil.getInstance():addTweenTargetScale(self.roundNumTxt.mainContent, 0.2, 0.2, 1, 1, 1);
		self:onUpdateRoleSkill();
		self:onUpdateBeastSkill();
	end

	if self.gradePanel ~= nil then
		self.gradePanel:setData(self._recordId);
	end
	
	if info.type == 2 then -- 释放技能
		local skillCfg = Lua_SkillConfigData.getConfigData(info.skill_id);
		if skillCfg == nil then
			return;
		end

		local fighterId = tonumber(tostring(info.fighter_id));
		local thing = DataCenter.thingData:getThingPlayer(self._recordVo.sceneId, self._recordId, fighterId);
		if thing == nil then
			local name = getConfig("strange_beasts", skillCfg.beastId, "fight_effect");
			self.skillObj_2:SetActive(false);
			self.skillObj_1:SetActive(true);
			if not strIsNullOrEmpty(name) then
				self:showSkillEff("/effects/uiEffects/"..name, name);

				self:hideSkillStar();
				Lua_CommonUtil.removeTimer(self, self.showSkillStar);
				Lua_CommonUtil.removeTimer(self, self.hideSkillStar);
				Lua_CommonUtil.delayCall(0.33, self, self.showSkillStar, skillCfg.beastStar); -- 10帧消失
				Lua_CommonUtil.delayCall(1, self, self.hideSkillStar); -- 30帧消失

				LuaUtil.setObjPos(self.skillObj_1, 0, 0, 0);
				local player = DataCenter.fightData:getFightPlayerById(self._recordId);
				local formationType = player:getBeastFormationType(fighterId);
				if formationType == Lua_FightDefine.FIGHT_ATTACKER then
					LuaUtil.setObjScale(self.skillObj_1, 1, 1, 1);
				else
					LuaUtil.setObjScale(self.skillObj_1, -1, 1, 1);
				end
			end
		else
			local kind = thing.player.data.kind;
			local formationType = thing.formationType;
			if kind == Lua_ThingDefine.PLAYER then
				self.skillObj_2:SetActive(false);
				self.skillObj_1:SetActive(true);
				self:showSkillEff("/effects/uiEffects/scenc_hanzhao", "scenc_hanzhao_"..skillCfg.artifactId);
				TweenUtil.getInstance():stop(self.skillObj_1);
				if formationType == Lua_FightDefine.FIGHT_ATTACKER then
					self.skillHideX1 = 1080;
					LuaUtil.setObjScale(self.skillObj_1, 1, 1, 1);
					LuaUtil.setObjPos(self.skillObj_1, -1080, -33, 0);
					TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, 0, -33, 0, 0, false);
				else
					LuaUtil.setObjScale(self.skillObj_1, -1, 1, 1);
					self.skillHideX1 = -1080;
					LuaUtil.setObjPos(self.skillObj_1, 1080, -33, 0);
					TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, 0, -33, 0, 0, false);
				end
				Lua_CommonUtil.delayCall(1 / self._recordVo.speed, self, self.hideskillObj1);
			else
				if skillCfg.skillType == 3 or skillCfg.skillType == 4 then
					self.skillObj_1:SetActive(false);
					self.skillObj_2:SetActive(true);
					self.skill_name_2.text = skillCfg.name;

					local config;
					local atlasName = nil;
					local spriteName = nil;
					if kind == Lua_ThingDefine.MONSTER then
						config = Lua_MonsterConfigData.getMonsterConfig(thing.objId);
					elseif kind == Lua_ThingDefine.HERO then
						config = Lua_HeroConfigData.getConfig(thing.objId);
					end
					if thing.fashionId > 0 then
						config = Lua_HeroFashionConfigData.getConfig(thing.fashionId);
					end
					if config ~= nil then
						atlasName = config.avatar_atlas_2;
						spriteName = config.avatar_sprite_2;
					end
					self.heroAvatar:setAltas(atlasName, spriteName);
					self.heroAvatar:resetSize();
					
					TweenUtil.getInstance():stop(self.skillObj_2);
					if formationType == Lua_FightDefine.FIGHT_ATTACKER then
						self.skill_bg_2:setScale(1, 1, 1);
						self.heroAvatar:setScale(1, 1, 1);
						self.skill_name_2.pivotValue = 3;
						self.skill_name_2:setLocation(140, -1, 0);
						self.skill_name_2.alignmentValue = 3;

						self.skillHideX2 = -1080;
						self.skillHideY = 108;
						LuaUtil.setObjPos(self.skillObj_2, -1080, 108, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, -360, 108, 0, 0, false);
					else
						self.skill_bg_2:setScale(-1, 1, 1);
						self.heroAvatar:setScale(-1, 1, 1);
						self.skill_name_2.pivotValue = 5;
						self.skill_name_2:setLocation(-140, -1, 0);
						self.skill_name_2.alignmentValue = 5;
						self.skillHideX2 = 1080;
						self.skillHideY = 225;
						LuaUtil.setObjPos(self.skillObj_2, 1080, 225, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, 360, 225, 0, 0, false);
					end
					Lua_CommonUtil.delayCall(1 / self._recordVo.speed, self, self.hideskillObj2);
				end
			end
		end 
	end
end

function Lua_FightMainWindow:hideskillObj1()
	TweenUtil.getInstance():stop(self.skillObj_1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, self.skillHideX1, -33, 0, 0, false);
end

function Lua_FightMainWindow:hideskillObj2()
	TweenUtil.getInstance():stop(self.skillObj_2);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, self.skillHideX2, self.skillHideY, 0, 0, false);
end

function Lua_FightMainWindow:showStartEff(index)
	local exitTime = 0;
	if index == 1 then
		if self._recordVo.bPlayedStartEff ~= true then
			self._recordVo.bPlayedStartEff = true;
			if self.startEffPanel == nil then
				if self.templateId == Lua_FightDefine.TEMPLATE_ID_KUNXU then
					self.startEffPanel = Lua_KunXuHolyLandStartFightPanel.new(self.content);
				else
					self.startEffPanel = Lua_FightIntoEffShowPanel.new(self.content);
					self.startEffPanel:setStart();
				end
			end
			exitTime = self.templateId == Lua_FightDefine.TEMPLATE_ID_KUNXU and DataCenter.kunXuHolyLandUtil.startFightTime or DataCenter.fightUtil.startEffectTime;
		end
	else
		if self.startEffPanel ~= nil then
			self.startEffPanel:dispose();
			self.startEffPanel = nil;
		end

		self:updateRoleInfo();
		self.startEffPanel = Lua_FightIntoEffShowPanel.new(self.content);
		self.startEffPanel:setLocation(0, GlobalVar.screenOffsetTopH, 0);
		self.startEffPanel:setIndex(index);
		exitTime = DataCenter.fightUtil.startEffectTime;
	end
	if exitTime > 0 then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false)
		end
		if self.beastsPanel then
			self.beastsPanel:setEnable(false)
		end
		Lua_CommonUtil.removeTimer(self, self.onOverStartEffShow);
		Lua_CommonUtil.delayCall(exitTime / self._recordVo.speedRate, self, self.onOverStartEffShow);
	end
end

function Lua_FightMainWindow:onOverStartEffShow()
	self.isPressSkip = nil;
	if self.startEffPanel ~= nil then
		self.startEffPanel:dispose();
		self.startEffPanel = nil;
	end
	self:onUpdateRoleSkill();
	self:onUpdateBeastSkill();
	self:updateFightPlot(self._recordVo.plotId);
end

function Lua_FightMainWindow:onSkillHurtUpdate(hurtVal)
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player == nil or player.bRunBack == true then
		self.hurtObj:SetActive(false);
		return;
	end

	local info = player.curPlayActionInfo;
	if info == nil or info.type ~= 2 then -- 非技能
		self.hurtObj:SetActive(false);
		return;
	end

	if hurtVal > 0 then
		if not self.hurtObj.activeSelf then
			self.hurtObj:SetActive(true);
			LuaUtil.setObjScale(self.hurtObj, 2, 2, 2)
			TweenUtil.getInstance():stop(self.hurtObj)
			TweenUtil.getInstance():addTweenTargetScale(self.hurtObj, 0.1, 0, 1, 1, 1)
		end
		
		if self.hurtNum == nil then
			self.hurtNum = Lua_NumberImage.new(self.hurtObj);
			self.hurtNum:setLocation(-120, -18, 0);
			self.hurtNum.pivot = 1;
			self.hurtNum.numOffsetX = -12;
			self.hurtNum.numAtlas = "number"
			self.hurtNum.preStr = "xui_zd_number_";
		end
		self.hurtNum.num = hurtVal;
		
		Lua_CommonUtil.delayCall(DataCenter.fightUtil.skillHurtWaitTime, self, self.onOverSkillHurtShow);
	else
		self.hurtObj:SetActive(false);
	end
end

function Lua_FightMainWindow:onOverSkillHurtShow()
	self.hurtObj:SetActive(false);
end

function Lua_FightMainWindow:onUpdateRoleSkill()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_1 then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false);
		end
		return;
	end

	if self.startEffPanel ~= nil then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false);
		end
		return;
	end

	-- 不播放开场动画则更新主角技能
	if self._recordVo ~= nil and self._recordVo.bPlayedStartEff ~= true then
		if self.artifactPanel then
			self.artifactPanel:setEnable(false);
		end
		return;
	end

	if self.artifactPanel == nil then
		self.artifactPanel = Lua_FightArtifactPanel.new(self.content);
		self.artifactPanel:setSiblingIndex(0);
		self.artifactPanel:setRectAnchor(9);
	end
	self.artifactPanel:setEnable(true);
	self.artifactPanel:setData(self._recordId);
end

function Lua_FightMainWindow:onUpdateBeastSkill()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_1 then
		if self.beastsPanel then
			self.beastsPanel:setEnable(false);
		end
		return;
	end
	
	if self.startEffPanel ~= nil then
		if self.beastsPanel then
			self.beastsPanel:setEnable(false);
		end
		return;
	end

	if self._recordVo ~= nil and self._recordVo.bPlayedStartEff ~= true then
		if self.beastsPanel then
			self.beastsPanel:setEnable(false);
		end
		return;
	end

	if self.beastsPanel == nil then
		self.beastsPanel = Lua_FightBeastsPanel.new(self.content);
		self.beastsPanel:setSiblingIndex(0);
		self.beastsPanel:setRectAnchor(9);
	end
	self.beastsPanel:setEnable(true);
	self.beastsPanel:setData(self._recordId);
end

function Lua_FightMainWindow:checkOperate()
	self.roundObj:SetActive(true)
	
	local list;
	if self._recordVo.isReplay == true then
		if self._recordVo.flag == Lua_FightDefine.REPLAY_VIDEO then
			list = self._recordVo.templateConfig.video_show;
		else
			list = self._recordVo.templateConfig.replay_show;
		end
	else
		list = self._recordVo.templateConfig.normal_show;
	end
	if list == nil then
		return;
	end

	local arr = Array(); -- 右下角操作按钮
	local _arr = Array(); -- 暂停操作选项按钮
	local len = #list
	local showPause = false;
	for i = 1, len do
		if list[i] == 3 then -- 暂停
			if DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.pauseCond) then
				showPause = true;
				arr:add(list[i]);
			end
		elseif list[i] == 5 then -- 显示波数
			self.rotationObj:SetActive(true);
		elseif list[i] == 6 then -- 分队信息
			local lineup = self._recordVo.attacker.lineup;
			if lineup ~= nil and lineup[2] ~= nil then
				self.rotationObj:SetActive(true);
				arr:add(list[i]);
			end
		elseif list[i] == 11 then -- 放弃战斗
			_arr:add(list[i]);
		elseif list[i] == 12 then -- 重新开始
			_arr:add(list[i]);
		else
			arr:add(list[i]);
		end
	end
	if showPause and _arr:indexOf(13) == -1 then
		_arr:add(13); -- 继续
	end
	if DataCenter.fightData.bShowSkinBtn and arr:indexOf(1) == -1 then
		arr:add(1);
	end

	if self.operateList == nil then
		self.operateList = Array()
	end
	len = self.operateList:getSize()
	for i = 1, len do
		self.operateList[i]:setEnable(false)
	end
	
	self.speedIcon = nil
	len = arr:getSize()
	local index = 1
	local posY
	local icon
	while len > 0 do
		icon = self.operateList[index]
		if icon == nil then
			icon = UICreate.createUIAtlasImage(self.showObject, nil, nil, 0, 0, 0, 0)
			self.operateList:add(icon)
		else
			icon:setEnable(true)
		end
		icon.anchorValue = 7
		posY = 55 + (index - 1) * 102
		if arr[len] == 0 then -- 加速
			icon:setAltas("fight_atlas_1", "xui_zd_button_01"..(self._recordVo.showSpeed + 3).."_n")
			self.speedIcon = icon
			self:createSpeedTips(posY)
		elseif arr[len] == 1 then -- 跳过
			icon:setAltas("fight_atlas_1", "xui_zd_button_021_n")
		elseif arr[len] == 2 then -- BUFF
			icon:setAltas("fight_atlas_1", "xui_zd_button_019_n")
		elseif arr[len] == 3 then -- 暂停
			icon:setAltas("fight_atlas_1", "xui_zd_button_018_n")
		elseif arr[len] == 4 then -- 挂起
			icon:setAltas("fight_atlas_1", "xui_zd_button_020_n")
			self:createHangTips(posY)
		elseif arr[len] == 6 then -- 分队信息
			icon:setAltas("fight_atlas_1", "xui_zd_button_027")
		elseif arr[len] == 14 then -- 增益
			icon:setAltas("fight_atlas_1", "xui_zd_button_028")
		end
		icon.name = arr[len]
		icon:resetSize()
		icon:setLocation(302, posY, 0)
		icon:addClickFuntion(self, self.onButtonClick)

		index = index + 1
		len = len - 1
	end

	if self.giveUpIcon then self.giveUpIcon:setEnable(false) end
	if self.replayIcon then self.replayIcon:setEnable(false) end
	if self.continueIcon then self.continueIcon:setEnable(false) end
	len = _arr:getSize()
	local spacingH = 180
	local w = spacingH * len
	w = - w / 2 + spacingH / 2;
	for i = 1, len do
		if _arr[i] == 11 then
			if self.giveUpIcon == nil then
				self.giveUpIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "xui_zd_button_005_n", 0, 0, 0, 0)
			end
			self.giveUpIcon:setEnable(true)
			self.giveUpIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.giveUpIcon.name = _arr[i]
			self.giveUpIcon:addClickFuntion(self, self.onButtonClick)
		elseif _arr[i] == 12 then
			if self.replayIcon == nil then
				self.replayIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "xui_zd_button_004_n", 0, 0, 0, 0)
			end
			self.replayIcon:setEnable(true)
			self.replayIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.replayIcon.name = _arr[i]
			self.replayIcon:addClickFuntion(self, self.onButtonClick)
		elseif _arr[i] == 13 then
			if self.continueIcon == nil then
				self.continueIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "xui_zd_button_006_n", 0, 0, 0, 0)
			end
			self.continueIcon:setEnable(true)
			self.continueIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.continueIcon.name = _arr[i]
			self.continueIcon:addClickFuntion(self, self.onButtonClick)
		end
    end
end

function Lua_FightMainWindow:onButtonClick(data)
	if type(data) == "userdata" then
		data = data.name;
	end
	data = tonumber(data);

	if data == 0 then -- 加速
		self:onSpeed();
	elseif data == 1 then -- 跳过
		self:onSkip();
	elseif data == 2 then -- BUFF
		self:onCheckBuff();
	elseif data == 3 then -- 暂停
		self:onPause();
	elseif data == 4 then -- 挂起
		self:onHang();
	elseif data == 6 then -- 分队信息
		self:onCheckQueue();
	elseif data == 11 then -- 放弃战斗
		self:onGiveUp();
	elseif data == 12 then -- 重新开始
		self:onReplay();
	elseif data == 13 then -- 继续
		self:onContinue();
	elseif data == 14 then -- 增益
		self:onCheckGain();
	end
end

function Lua_FightMainWindow:onSpeedChange()
	if self.speedIcon then
		self.speedIcon:setAltas("fight_atlas_1", "xui_zd_button_01"..(self._recordVo.showSpeed + 3).."_n")
	end
	if self.bossHurtPanel ~= nil then
		self.bossHurtPanel:setSpeedRate(self._recordVo.speedRate);
	end
end

-- 速度
function Lua_FightMainWindow:onSpeed()
	local idx = self._recordVo.speedIdx;
	local templateCfg = self._recordVo.templateConfig;
	if idx >= self._recordVo.speedMaxIdx then
		idx = 1;
	else
		idx = idx + 1;
		if idx > 2 and not templateCfg:checkSpeedIsOpen(idx) then
			idx = 1;
		end
	end
	
	if idx > 1 and self._recordVo.isReplay ~= true and templateCfg.speedCond ~= nil and #templateCfg.speedCond >= idx - 1 then
		if DataCenter.funcOpenData:isOpened(templateCfg.speedCond[idx - 1], true) == false then
			return;
		end
	end

	self._recordVo.speedIdx = idx;
	if self.speedTips then
		if not self:createSpeedTips() then
			self.speedTips:dispose()
			self.speedTips = nil

			self.speedEff:dispose();
			self.speedEff = nil;
		end
	end
end

-- 跳过
function Lua_FightMainWindow:onSkip()
	if self._recordVo and self._recordVo.haveResult and not DataCenter.fightData:checkIsExistResult(self._recordId) then
		OperateAlert.showLangValue(302012);
		return;
	end
	
	if getTime() - DataCenter.fightData.startReplayTime < 1.5 then
		return;
	end

	if not self:checkCanSkip() or self.isPressSkip == true then
		return;
	end
	self.isPressSkip = true

	local player;
	local vo;
	if self._recordVo.groupId > 0 then
		-- 组队
		local arr = DataCenter.fightData:getGroupArrById(self._recordVo.groupId);
		if arr ~= nil then
			for i = 1, arr:getSize() do
				vo = DataCenter.fightData:getRecordVoById(arr[i]);
				if vo then
					vo:checkResult();
				end

				player = DataCenter.fightData:getFightPlayerById(arr[i]);
				if player and player.isPlayEnd ~= true then
					player:playEnd(true);
				end
			end
		end
	elseif self._recordVo.teamId > 0 then
		-- 分队
		local arr = DataCenter.fightData:getTeamArrById(self._recordVo.teamId);
		if arr ~= nil then
			for i = 1, arr:getSize() do
				vo = DataCenter.fightData:getRecordVoById(arr[i]);
				if vo then
					vo:checkResult();
				end

				player = DataCenter.fightData:getFightPlayerById(arr[i]);
				if player and player.isPlayEnd ~= true then
					player:playEnd(true);
				end
			end
		end
	else
		self._recordVo:checkResult();
		player = DataCenter.fightData:getFightPlayerById(self._recordId);
		player:playEnd(true);
	end
end

function Lua_FightMainWindow:checkCanSkip()
	if self._recordVo ~= nil and self._recordVo.isReplay ~= true then
		if self.templateId == Lua_FightDefine.TEMPLATE_ID_ARENA then
			local limitTimes = DataCenter.arenaUtil:getConstConfig("skip_fight_times", 1);
			if DataCenter.arenaData.fight_times < limitTimes then
				OperateAlert.show(LanUtil.formateStr(303024, tostring(limitTimes)));
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST then
			local skipTimes = DataCenter.chaosForestUtil.fightSkipTimes;
			if DataCenter.chaosForestData.challenge_times < skipTimes then
				OperateAlert.show(LanUtil.formateStr(340031, tostring(skipTimes)));
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_PEAKDUEL then
			if not DataCenter.warOrderData:advActiveState(Lua_WarOrderData.PeakDuel, 1) then
				OperateAlert.showLangValue(202936);
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_STARTRIAL then
			if DataCenter.starTrialData.curChapter <= DataCenter.starTrialUitl.needPassChapter then
				if not DataCenter.starTrialUitl:getStateByStageId(self._recordVo.stageId) then
					OperateAlert.show(LanUtil.formateStr(201630, DataCenter.starTrialUitl.needPassChapter));
					return false;
				end
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then
			local data = DataCenter.equipCopyUtil:getSingleCapyVoById(self._recordVo.stageId);
			if data then
				local camp = data.camp;
				local diff = data.difficulty;
				local bSkip = DataCenter.equipCopyData:bSkipFightByDifficulty(camp,diff);
				if not bSkip then
					OperateAlert.show(LanUtil.formateStr(420105, DataCenter.equipCopyUtil.skip_fight_score));
					return false;
				end
			else
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_HEROTRIAL_LEVEL
			or self.templateId == Lua_FightDefine.TEMPLATE_ID_HEROTRIAL_ENDLESS then
			if DataCenter.newHeroActData:getCurHeroTrialFightSkipState() then
				OperateAlert.showLangValue(750021);
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_TIME_SPACE_RACE then
			local hisRank = DataCenter.timeSpaceRaceData.hisRank;
			local config = DataCenter.timeSpaceRaceUtil:getTimeSpaceConfig(self._recordVo.stageId);
			if hisRank <= 0 or hisRank > config.skip_rank then
				OperateAlert.show(LanUtil.formateStr(770029, tostring(config.skip_rank)));
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_FORMTEAMCOMPETITAION then
			if DataCenter.formTeamCompetitionData:checkPassFight(true) ~= true then
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVE then
			if not DataCenter.wildSecretData.isFightSkip then
				OperateAlert.showLangValue(701089);
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_HEROCHALLENGE then
			local drawState = DataCenter.heroChallengeData.daily_reward_state;
			if drawState == 0 then
				OperateAlert.showLangValue(680024);
				return false;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_GODSEAPEAK then
			local limitTimes = DataCenter.godSeaPeakUtil.skipFightTimes;
			if DataCenter.godSeaPeakData.winTimes < limitTimes then
				OperateAlert.show(LanUtil.formateStr(790029, tostring(limitTimes)));
				return;
			end
		elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOS_COPY then
			local stageId = DataCenter.chaosCopyUtil.fightSkipLimit;
			if not DataCenter.chaosCopyData:checkStageIsPass(stageId) then
				local config = DataCenter.chaosCopyUtil:getStageConfig(stageId);
				OperateAlert.show(LanUtil.formateStr(796034, config.stage_name));
				return;
			end
		end

		if self._recordVo.isReplay ~= true then
			if not DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.skipCond, true) then
				return false;
			end
		end
	end
	return true;
end

-- 状态
function Lua_FightMainWindow:onCheckBuff()
	Lua_WindowUtil.openWin("Lua_FightOverallBuffWindow", Lua_WinParam.ACTION_OPEN, self._recordId);
end

-- 暂停
function Lua_FightMainWindow:onPause()
	self.maskObj:SetActive(true);
	DataCenter.fightData:controllFightPlay(self._recordId, false);
end

-- 切换到后台
function Lua_FightMainWindow:onHang()
	if self._recordVo.isReplay ~= true then
		if not DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.hangCond, true) then
			return;
		end
	end

	if self.isPressHang == nil then -- 防止多次点击挂起按钮
		self.isPressHang = true;
		if self._recordVo.templateConfig.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then -- 主线
			local vo = DataCenter.funcPathUtil:getFuncPathVo(1005)
			if not vo.isShowing then
				DataCenter.funcPathUtil:gotoFunction(1005, true, false)
			end
		end
		DataCenter.fightData:hideFightToBackStageByRecordId(self._recordId);
		DataCenter.fightData:showNextResult(); -- 切换到后台后，是否有结算界面需显示
		DataCenter.funcPathUtil:clearFightRecordFuncPath(self._recordId);

		if self.hangTips then
			Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_hang_tips", 1)
			self.hangTips:dispose()
			self.hangTips = nil

			self.hangEff:dispose();
			self.hangEff = nil;
		end
	end
end

-- 查看队列
function Lua_FightMainWindow:onCheckQueue()
	Lua_WindowUtil.openWin("Lua_FightQueueWindow", Lua_WinParam.ACTION_OPEN, self._recordId);
end

function Lua_FightMainWindow:onBlackMaskClick(go)
	self.maskObj:SetActive(false);
	DataCenter.fightData:controllFightPlay(self._recordId, true);
end

-- 放弃
function Lua_FightMainWindow:onGiveUp()
	self.maskObj:SetActive(false);
	local value = self._recordVo.isIgnoreResult;
	DataCenter.fightData:removeFightResult(self._recordId);
	DataCenter.fightData:removeFight(self._recordId);
	if value == false then
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightResult(self._recordId, 2, self.curRotation);
	end
end

-- 重播
function Lua_FightMainWindow:onReplay()
	self.maskObj:SetActive(false);
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightResult(self._recordId, 2, self.curRotation);

	DataCenter.fightData:removeFightResult(self._recordId);
	local msg = DataCenter.fightData:getSendFightMsg(self.templateId);
	if msg then
		DataCenter.fightData.curPlayFightRecordId = 0
		DataCenter.fightData.removeFightId = self._recordId
		sendMsg(10102001, msg);
	else
		self:onSkillHurtUpdate(0)
		DataCenter.fightData:replayFight(self._recordId);
	end
end

-- 继续
function Lua_FightMainWindow:onContinue()
	self.maskObj:SetActive(false);
	DataCenter.fightData:controllFightPlay(self._recordId, true);
end

-- 增益
function Lua_FightMainWindow:onCheckGain()
	Lua_WindowUtil.openWin("Lua_InfinityHallBuffWindow", Lua_WinParam.ACTION_OPEN, self.templateId);
end

function Lua_FightMainWindow:createPanel()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_STARTRIAL then
		self:createStarPanel()
		local arr = DataCenter.starTrialUitl:getStageVo(self._recordVo.stageId).starCondArr;
		self.starPanel:setData(self._recordId, arr);
		self.starPanel:setShowHide(true)
		self.starPanel:setAutoHide(5)
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST then -- BOSS伤害
		self:createBossHurt();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then
		self:createGradePanel();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_MORE then
		self:createGradePanel()
		self:createTeamUpPanel();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_KUNXU then -- 战斗分队
		self:createStarPanel()
		local arr = DataCenter.kunXuHolyLandData:getLevelInfoById(self._recordVo.stageId).starCondArr
		self.starPanel:setData(self._recordId, arr);
		self:createDetachment()
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_LEAGUEDUELBOSS then
		self:createBossHurt();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_BOSSCHALLENGE then -- BOSS挑战血条伤害
		self:createBossHurt(1);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_HEROCHALLENGE then -- 英雄挑战血条伤害
		self:createBossHurt(1);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_HEROTRIAL_ENDLESS then -- 新英雄英雄试炼无限模式血条伤害
		self:createBossHurt(1);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_SPECIAL_LAST_DIVINEDOMAINTRIAL and DataCenter.divineDomainTrialUtil:checkHurtFight(self._recordVo.stageId) then -- 是否是神域试炼特殊副本且是最后一关：伤害挑战
		self:createBossHurt();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_TIME_SPACE_RACE and not self._recordVo.isReplay then -- 时空争霸
		self:createUnitState();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL then -- 无尽关卡
		if self.desBg == nil then
			self.desBg = UICreate.createUIAtlasImage(self.content, "endless_level_atlas", "xui_dbzl_widget_24", 0, -141, 0, 0);
			self.desBg.anchorValue = 1;
		end
		if self.desTxt == nil then
			self.desTxt = UICreate.createLabel(self.content, nil, 0, -140, 100, 30, 22);
			self.desTxt.anchorValue = 1;
			self.desTxt.alignmentValue = 4;
			self.desTxt.horizontalOverflowValue = 1;
			self.desTxt.colorStr = Lua_ColorDefine.transColorStr("FBEBAB");
		end
		self.desTxt.text = LanUtil.formateStr(779000, self._recordVo.endlessLevelScore);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOS_COPY then
		if self.condPanel == nil then
			self.condPanel = Lua_ChaosCopyCondPanel.new(self.showObject);
			self.condPanel:setRectAnchor(1);
			self.condPanel:setLocation(-325, -240.5, 0);
		end
		self.condPanel:setShowHide(true);
		self.condPanel:setAutoHide(5);
		self.condPanel:setData(self._recordVo.stageId);
		if self._recordVo.teamId > 0 then
			self:createDetachment();
		end
	end
end

-- 战斗星级
function Lua_FightMainWindow:createStarPanel()
	if self.starPanel == nil then
		self.starPanel = Lua_FightStarPanel.new(self.showObject);
		self.starPanel:setRectAnchor(1);
		self.starPanel:setLocation(-325, -240.5, 0)
	end
end

-- 战斗评级
function Lua_FightMainWindow:createGradePanel()
	self.roundObj:SetActive(false);
	if self.gradePanel == nil then
		self.gradePanel = Lua_FightGradePanel.new(self.showObject);
		self.gradePanel:setRectAnchor(1);
		self.gradePanel:setLocation(171, -314, 0);
	end
	self.gradePanel:setShowHide(true);
	self.gradePanel:setAutoHide(3);
end

-- 战斗组队
function Lua_FightMainWindow:createTeamUpPanel()
	if self.teamUpPanel == nil then
		self.teamUpPanel = Lua_FightTeamUpPanel.new(self.showObject)
		self.teamUpPanel:setRectAnchor(1);
		self.teamUpPanel:setLocation(0, -260, 0);
	end
	self.teamUpPanel:setShowHide(true);
	self.teamUpPanel:setAutoHide(3)
end

-- BOSS伤害
function Lua_FightMainWindow:createBossHurt(key)
	if self.bossHurtPanel == nil then
		if key == 1 then
			self.bossHurtPanel = Lua_FightBossChallengeHurtPanel.new(self.showObject);
		else
			self.bossHurtPanel = Lua_FightBossHurtPanel.new(self.showObject);
		end
		self.bossHurtPanel:setRectAnchor(1);
	end
	self.bossHurtPanel:setData(self._recordId);
end

-- 战斗分队
function Lua_FightMainWindow:createDetachment()
	if self.detachmentPanel == nil then
		self.detachmentPanel = Lua_FightDetachmentPanel.new(self.showObject);
	end
	self.detachmentPanel:setData(self._recordId)
end

function Lua_FightMainWindow:createUnitState()
	if self.unitStatePanel == nil then
		self.unitStatePanel = Lua_FihgtUnitStatePanel.new(self.showObject);
		self.unitStatePanel:setRectAnchor(1);
		self.unitStatePanel:setLocation(0, -111, 0);
	end
	self.unitStatePanel:setData(self._recordId)
end

function Lua_FightMainWindow:clearPanel()
	if self.bossHurtPanel then
		self.bossHurtPanel:dispose()
		self.bossHurtPanel = nil
	end
	if self.starPanel then
		self.starPanel:dispose()
		self.starPanel = nil
	end
	if self.gradePanel then
		self.gradePanel:dispose()
		self.gradePanel = nil
	end
	if self.teamUpPanel then
		self.teamUpPanel:dispose()
		self.teamUpPanel = nil
	end
	if self.detachmentPanel then
		self.detachmentPanel:dispose()
		self.detachmentPanel = nil
	end
	if self.unitStatePanel then
		self.unitStatePanel:dispose();
		self.unitStatePanel = nil;
	end
	if self.condPanel then
		self.condPanel:dispose();
		self.condPanel = nil;
	end
end

function Lua_FightMainWindow:createSpeedTips(posY)
	local templateConfig = self._recordVo.templateConfig
	local idx = self._recordVo.speedIdx;
	local value = DataCenter.roleData:getOperationRecord("fight_speed_x"..(idx + 1));
	if idx < self._recordVo.speedMaxIdx and value ~= 1 and templateConfig:checkSpeedIsOpen(idx + 1) then
		if self.speedTips == nil then
			self.speedTips = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_qp", "ui_zx_qp", 0, 0)
			self.speedTips.anchorValue = 7
			self.speedTips:setScale(-1, 1, 1)
			self.speedTips:setLocation(175, posY + 30, 0)

			self.speedEff = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_zdan", "ui_zx_zdan", 0, 0)
			self.speedEff.anchorValue = 7;
			self.speedEff:setLocation(302, posY, 0);
		end
		self.speedTips:setEnable(true)
		self.speedEff:setEnable(true)
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_speed_x"..(idx + 1), 1);
		return true
	else
		if self.speedTips then
			self.speedTips:setEnable(false)
		end
		if self.speedEff then
			self.speedEff:setEnable(false)
		end
	end
	return false
end

function Lua_FightMainWindow:createHangTips(posY)
	local bOpened = DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.hangCond)
	local value = DataCenter.roleData:getOperationRecord("fight_hang_tips")
	if bOpened and value ~= 1 then
		if self.hangTips == nil then
			posY = posY or 0
			self.hangTips = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_qp", "ui_zx_qp", 0, 0)
			self.hangTips:setScale(-1, 1, 1)
			self.hangTips.anchorValue = 7
			self.hangTips:setLocation(175, posY + 30, 0)

			self.hangEff = UICreate.createUIEffect(self.showObject, "/effects/uiEffects/ui_zx_zdan", "ui_zx_zdan", 0, 0)
			self.hangEff.anchorValue = 7;
			self.hangEff:setLocation(299, posY + 7, 0);
		end
		self.hangTips:setEnable(true)
		self.hangEff:setEnable(true)
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOperate("fight_hang_tips", 1)
	else
		if self.hangTips then
			self.hangTips:setEnable(false)
		end
		if self.hangEff then
			self.hangEff:setEnable(false)
		end
	end
end

-- 引导同步
function Lua_FightMainWindow:updateGuide(guideId, info)
	if info == nil then
		return;
	end
	
end

function Lua_FightMainWindow:onServerPlotUpdate(eid)
	if self.fightPlotPanel ~= nil then
		self.fightPlotPanel:updateServerPlot(eid);
	end
end

-- 战斗剧情
function Lua_FightMainWindow:updateFightPlot(plotId)
	if plotId > 0 then
		local cfg = getConfig("tb_fight_plot", plotId);
		if cfg ~= nil and cfg.event_list ~= nil and #cfg.event_list > 0 then
			if self.fightPlotPanel == nil then
				self.fightPlotPanel = Lua_FightPlotPanel.new(self.content);
				-- self.fightPlotPanel:setRectAnchor(9);
			end
			self.fightPlotPanel:playPlot(self._recordId, plotId, cfg);
			return;
		end
	end

	if self.fightPlotPanel ~= nil then
		self.fightPlotPanel:dispose();
		self.fightPlotPanel = nil;
	end
end

function Lua_FightMainWindow:onUpdateBossInfo(thingUnId)
	if thingUnId == nil then
		return;
	end

	local thing = DataCenter.thingData:getThingPlayer(self._recordVo.sceneId, self._recordId, thingUnId);
	if thing == nil or thing.fightRecordId ~= self._recordId then
		return
	end

	if self.bossInfoPanel == nil then
		self.bossInfoPanel = Lua_FightBossInfoPanel.new(self.showObject)
		self.bossInfoPanel:setRectAnchor(1)
		self.bossInfoPanel:setLocation(0, -193, 0)
	end
	self.bossInfoPanel:setEnable(true)
	self.bossInfoPanel:setData(thing.data)
end

function Lua_FightMainWindow:onUpdateBossBuff(thingUnId)
	if thingUnId == nil or self.bossHurtPanel == nil then
		return;
	end

	local thing = DataCenter.thingData:getThingPlayer(self._recordVo.sceneId, self._recordId, thingUnId);
	if thing == nil or thing.fightRecordId ~= self._recordId then
		return
	end

	self.bossHurtPanel:updateBuff(thing.data);
end

function Lua_FightMainWindow:showSkillEff(url, name)
	if strIsNullOrEmpty(url) or strIsNullOrEmpty(name) then
		if self.skillEff then
			self.skillEff:setEnable(false);
		end
	else
		if self.skillEff == nil then
			self.skillEff = UICreate.createUIEffect(self.skillObj_1, url, name, 0, 100);
			self.skillEff.siblingIndex = 1;
		else
			self.skillEff:setUrl(url, name);
			self.skillEff:setEnable(false);
			self.skillEff:setEnable(true);
		end
	end
end

function Lua_FightMainWindow:showSkillStar(num)
	if self.skillStarList == nil then
		self.skillStarList = Array();
	end
	local len = self.skillStarList:getSize();
	local maxLen = num > len and num or len;
	local star;
	for i = 1, maxLen do
		star = self.skillStarList[i];
		if i > num then
			if star then
				star:setEnable(false);
			end
		else
			if star == nil then
				star = UICreate.createUIAtlasImage(self.skillObj_1, "common_altas_1", "ui_common_toggle_002_f", 0, 0, 0, 0);
				self.skillStarList:add(star);
			else
				star:setEnable(true);
			end
		end
	end

	local space = 60;
	local w = -(space * num) / 2 + space / 2 + 175;
	for i = 1, num do
		star = self.skillStarList[i];
		star:setLocation(((i - 1) % num) * space + w, -115, 0);
	end
end

function Lua_FightMainWindow:hideSkillStar()
	if self.skillStarList then
		local len = self.skillStarList:getSize();
		for i = 1, len do
			self.skillStarList[i]:setEnable(false);
		end
	end
end

function Lua_FightMainWindow:removeSkillStar()
	Lua_CommonUtil.removeTimer(self, self.showSkillStar);
	Lua_CommonUtil.removeTimer(self, self.hideSkillStar);
	if self.skillStarList then
		self.skillStarList:dispose();
		self.skillStarList:clear();
		self.skillStarList = nil;
	end
end