-- 组队战斗伤害总览
checkRequire("Lua_FightOverallHurtWindow");
Lua_FightMoreHurtWindow = class("Lua_FightMoreHurtWindow", Lua_FightOverallHurtWindow);
function Lua_FightMoreHurtWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_FightMoreHurtWindow";
	self.skinName = "FightOverallHurtWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_FightMoreHurtWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
	self.buttonList:setSiblingIndex(0);
	self.buttonList:setRectPivot(3);
	self.buttonList:setLocation(-325, -(self.winBg.height / 2 - 3), 0);
	self.buttonList:setButtonCell(Lua_FightMoreHurtCell)
	self.buttonList:setButtonItem(133, 77);
	self.buttonList:setClickCallBack(self, self.onButtonClick)
end

function Lua_FightMoreHurtWindow:dispose()
	if self.buttonList then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	self:superCall("dispose");
end

function Lua_FightMoreHurtWindow:showWin(param)
	self:superCall("showWin", param);

	local index
	for i = 1, #param do
		if DataCenter.roleData:isMyself(param[i].hurt_collect_list[1].attacker.id) then
			index = i
			break
		end
	end
	self.buttonList:setData(param)
	self.buttonList:setSelected(index)
end

function Lua_FightMoreHurtWindow:onButtonClick(index)
	self:updateHurtInfo(self.showData[index])
end










Lua_FightMoreHurtCell = class("Lua_FightMoreHurtCell", Lua_ButtonCell);
function Lua_FightMoreHurtCell:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FightMoreHurtCell:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_tab_002", 0, 0, 0, 0);

	self.title = UICreate.createLabel(self.content, nil, 0, 10, 100, 31, 30);
	self.title.pivotValue = 4;
	self.title.alignmentValue = 4;
	self.title.horizontalOverflowValue = 1;
	self.title.fontName = Lua_MyUISettings.huakangFontName;
	self.title.colorStr = Lua_ColorDefine.transColor("7A6A5F");
end

function Lua_FightMoreHurtCell:dispose()
	self.bg = nil;
	self.title = nil;
	self:superCall("dispose");
end

function Lua_FightMoreHurtCell:setData(data)
	self.title.text = LanUtil.formateStr(420090, Lua_CommonUtil.transChineseNumber(self.index));
end

function Lua_FightMoreHurtCell:setSelected(index)
    if index == self.index then -- 选中
        self.bg:setAltas("common_altas_1", "xui_common_tab_001");
        self.title.colorStr = Lua_ColorDefine.transColor("8F5123");
    else
        self.bg:setAltas("common_altas_1", "xui_common_tab_002");
        self.title.colorStr = Lua_ColorDefine.transColor("7A6A5F");
    end
end

function Lua_FightMoreHurtCell:setCanClick(bCan)
	if bCan == true then
		self.bg.mouseEnable = true
		self.bg:addClickFuntion(self, self.onPressClick)
	else
		self.bg.mouseEnable = false
		self.bg:removeClickFuntion(self, self.onPressClick)
	end
end