checkRequire("Lua_FightBossHurtPanel");
Lua_FightBossChallengeHurtPanel = class("Lua_FightBossChallengeHurtPanel", Lua_FightBossHurtPanel);

function Lua_FightBossChallengeHurtPanel:onTimer()
	local dt;
	if self.wait_time > 0 then
		self.hurtBar:setSecondMaxValue(self.maxValue);
		self.hurtBar:setSecondValue(self.secondTarget);

		dt = getTime() - self.startTime;
		self.wait_time = self.wait_time - dt;
		if self.wait_time <= 0 then
			self.wait_time = 0;
		end
		self.startTime = getTime();
    else
		if self.addValue <= 0 then
			self:endTimer();
			return;
		end

		local t = getTime();
		dt = (t - self.startTime) *  self.speedRate;
		self.startTime = t;

		local num = self.addValueStep * dt;
		self.addValue = self.addValue - num;
		if self.addValue <= 0 then
			num = num + self.addValue;
		end
		self.showValue = self.showValue + num;

		local index, curValue, prevValue, isFinally = self:getMaxHurt();
		if self.showValue >= self.maxValue then
			self.showValue = self.showValue - self.maxValue;

			if index ~= nil then
				self.stepText.text = LanUtil.formateStr(10043, index);
			else
				self.stepText.text = "Max";
			end
			self.maxHurt = curValue;
			self.maxValue = curValue - prevValue;
			self.isFinally = isFinally;

			self.secondTarget = 0;
			self.hurtBar:setSecondValue(self.secondTarget);
			if self.addValue > self.maxValue then
				self.secondTarget = self.maxValue;
			else
				self.secondTarget = self.addValue;
			end
			self.wait_time = self.aniWait;
			self.startTime = getTime();
		end

		if self.isFinally and self.curHurt > self.maxHurt then
			self:showMaxHurt();
		else
			if self.isFinally then
				self.hurtBar:setSecondMaxValue(1);
				self.hurtBar:setSecondValue(1);
				self.hurtBar:setMaxValue(1);
				self.hurtBar:setValue(1);
			else
				self.hurtBar:setMaxValue(self.maxValue);
				self.hurtBar:setPercent(self.showValue / self.maxValue);
			end
		end

		self.curHurt = self.curHurt + num;
		self.curHurt = self.curHurt > self.totalHurt and self.totalHurt or self.curHurt;
		if index ~= nil then
			self.hurtBar:setText(LanUtil.formateStr(10044, tostring(getPreciseDecimal(self.curHurt, 0)), tostring(self.maxHurt)));
		else
			self.hurtBar:setText(tostring(getPreciseDecimal(self.curHurt, 0)));
		end
	end
end