-- 分队
Lua_FightDetachmentPanel = class("Lua_FightDetachmentPanel", Lua_DisplayObject);
function Lua_FightDetachmentPanel:ctor(p)
    self:superCall("ctor", p, "FightDetachmentPanel_skin")
end

function Lua_FightDetachmentPanel:buildShowItem()
    self:superCall("buildShowItem")
    self:addLuaEvent("FIGHTPLAY_CHECK_UPDATE", self, self.updateData);
    self:addLuaEvent("FIGHTPLAY_ENTER", self, self.updateData);

    self.defenderHp.typeValue = 3
    self.defenderHp.fillMethodValue = 3
    self.defenderHp.fillOrigin = 0
    self.defenderHp.fillAmount = 0

    self.attackerHp.typeValue = 3
    self.attackerHp.fillMethodValue = 3
    self.attackerHp.fillOrigin = 2
    self.attackerHp.fillAmount = 0

    self.btnChange:addClickFuntion(self, self.onChange)
end

function Lua_FightDetachmentPanel:dispose()
    self:superCall("dispose")
end

function Lua_FightDetachmentPanel:setData(recordId)
    self.recordId = recordId;
    self:updateData();
end

function Lua_FightDetachmentPanel:updateData()
    local recordVo = DataCenter.fightData:getRecordVoById(self.recordId);
    local player = DataCenter.fightData:getFightPlayerById(self.recordId)
    if player and player.isPlayEnd == true then
        self.tipsObject:SetActive(true)
        self.resultIcon:setAltas("fight_atlas_1", "xui_kxsd_title_1");--"ui_zd_icon_01"..recordVo.result);
    else
        self.tipsObject:SetActive(false)
    end

    self.otherId = nil
    local arr = DataCenter.fightData:getTeamArrById(recordVo.teamId)
    if arr == nil then
        return
    end

    for i = 1, arr:getSize() do
        if arr[i] ~= self.recordId then
            self.otherId = arr[i]
            break
        end
    end

    recordVo = DataCenter.fightData:getRecordVoById(self.otherId)
    if recordVo then
        local maxHp = recordVo.defenderMaxHp or 1
        local hp = recordVo.defenderHp or 0
        self.defenderHp.fillAmount = hp / maxHp

        maxHp = recordVo.attackerMaxHp or 1
        hp = recordVo.attackerHp or 0
        self.attackerHp.fillAmount = hp / maxHp
    end
end

function Lua_FightDetachmentPanel:onChange(go)
    if self.otherId == nil then
        return;
    end
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.showLangValue(10031);
        return;
    end
    self.clickTime = getTime();
    DataCenter.fightData:showFightToStageByRid(self.otherId);
end