--- 进场动画
checkRequire("Lua_RotAction");
Lua_FightIntoEffShowPanel = class("Lua_FightIntoEffShowPanel", Lua_DisplayObject);
function Lua_FightIntoEffShowPanel:ctor(p)
    self:superCall("ctor", p, nil);
end

function Lua_FightIntoEffShowPanel:buildShowItem()
    self:superCall("buildShowItem");
    local time = DataCenter.fightUtil.startEffectTime;
    if time > 0.4 then
    	time = time - 0.4;
    end

	self.maskBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_mask_01", 0, 0, 2048, 2048);
	self.maskBg.clickScale = false;
	self.maskBg.clickSound = nil;
	self.maskBg:addClickFuntion(self, self.onMaskClick);

	self.statrImg1 = UICreate.createImage(self.content, "/images/fight/ui_zd_widget_021.png", 0, 110, 0, 0);
	self.statrImg2 = UICreate.createImage(self.content, "/images/fight/ui_zd_widget_022.png", 0, 110, 0, 0);

	self.rotAct1 = Lua_RotAction.new(self.statrImg1);
	self.rotAct1:setParams(-360 / time, -360);

	self.rotAct2 = Lua_RotAction.new(self.statrImg2);
	self.rotAct2:setParams(360 / time, 360);
end

function Lua_FightIntoEffShowPanel:dispose()
	if self.startText ~= nil then
		TweenUtil.getInstance():stop(self.startText.mainContent);
		self.startText = nil;
	end
	if self.numberImg ~= nil then
		self.numberImg:dispose();
		self.numberImg = nil;
	end
    if self.showObject ~= nil and IsNil(self.showObject) == false then
        UnityEngine.GameObject.Destroy(self.showObject);
        self.showObject = nil;
    end
	if self.rotAct1 ~= nil then
		self.rotAct1:dispose();
		self.rotAct1 = nil;
	end
	if self.rotAct2 ~= nil then
		self.rotAct2:dispose();
		self.rotAct2 = nil;
	end
    self:superCall("dispose");
end

function Lua_FightIntoEffShowPanel:reset()
	self.rotAct1:stop();
	self.rotAct1:setRot(0);
	self.rotAct1:start();
	self.rotAct2:stop();
	self.rotAct2:setRot(0);
	self.rotAct2:start();
end

function Lua_FightIntoEffShowPanel:setStart()
	self:reset();
	if self.showObject ~= nil then
		TweenUtil.getInstance():stop(self.showObject);
		self.showObject:SetActive(false);
	end
	if self.startText == nil then
		self.startText = UICreate.createUIAtlasImage(self.content, "fight_atlas_2", "ui_zd_widget_023", 0, 110, 540, 482);
	end
	TweenUtil.getInstance():stop(self.startText.mainContent);
	self.startText:setEnable(true);
	self.startText:setScale(2, 2, 2);
	TweenUtil.getInstance():addTweenTargetScale(self.startText.mainContent, 0.35, 0, 1, 1, 1);
end

function Lua_FightIntoEffShowPanel:setIndex(num)
	self:reset();
	if self.startText ~= nil then
		TweenUtil.getInstance():stop(self.startText.mainContent);
		self.startText:setEnable(false);
	end
	if self.showObject == nil then
		self.showObject = UICreate.createGameObject(self.content, 0, 0, 0);
	end
	if self.numBg == nil then
		self.numBg = UICreate.createUIAtlasImage(self.showObject, "fight_atlas_2", "ui_zd_widget_024", 0, 110, 540, 482);
	end
	if self.numberImg == nil then
		self.numberImg = Lua_NumberImage.new(self.showObject);
		self.numberImg:setLocation(0, 110, 0);
		-- self.numberImg.numOffsetX = -3;
		self.numberImg.numAtlas = "number";
		self.numberImg.firstStr = "ui_zd_widget_031";
		self.numberImg.lastStr = "ui_zd_widget_032";
		self.numberImg.preStr = "ui_zd_number_0";
	end
	self.numberImg.num = num;

	TweenUtil.getInstance():stop(self.showObject);
	self.showObject:SetActive(true);
	LuaUtil.setObjScale(self.showObject, 2, 2, 2);
	TweenUtil.getInstance():addTweenTargetScale(self.showObject, 0.35, 0, 1, 1, 1);
end

function Lua_FightIntoEffShowPanel:onMaskClick(go)

end