-- 战斗分队状态
Lua_FihgtUnitStatePanel = class("Lua_FihgtUnitStatePanel", Lua_DisplayObject)
function Lua_FihgtUnitStatePanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FihgtUnitStatePanel:buildShowItem()
	self:superCall("buildShowItem");
	self.itemArr = Array();

	self:addLuaEvent("FIGHTPLAY_ROTATION_CHANGE", self, self.updateShowInfo)
end

function Lua_FihgtUnitStatePanel:dispose()
	if self.itemArr then
		self.itemArr:dispose();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end

function Lua_FihgtUnitStatePanel:setData(recordId)
	self.recordId = recordId;
	self:updateShowInfo();
end

function Lua_FihgtUnitStatePanel:updateShowInfo(curRotation)
	local player = DataCenter.fightData:getFightPlayerById(self.recordId);
	local dataLen = curRotation or player.curRotation;
	local len = self.itemArr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	local isFighting;
	for i = 1, maxLen do
		item = self.itemArr[i];
		if i > dataLen then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_FihgtUnitStateItem.new(self.content);
				self.itemArr:add(item);
			else
				item:setEnable(true);
			end
			isFighting = (i == dataLen);
			item:setData(i, isFighting, self.recordId);
		end
	end

	if dataLen > 0 then
		local space = 45;
		local w = -(space * dataLen) / 2 + space / 2;
		for i = 1, dataLen do
			self.itemArr[i]:setLocation(((i - 1) % dataLen) * space + w, 0, 0);
		end	
	end
end










Lua_FihgtUnitStateItem = class("Lua_FihgtUnitStateItem", Lua_DisplayObject)
function Lua_FihgtUnitStateItem:ctor(p)
	self:superCall("ctor", p, "FihgtUnitStateltem_skin");
end

function Lua_FihgtUnitStateItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FihgtUnitStateItem:dispose()
	if self.fightEff then
		self.fightEff:dispose();
		self.fightEff = nil;
	end
	self:superCall("dispose");
end

function Lua_FihgtUnitStateItem:setData(index, isFighting, recordId)
	if isFighting then
		self.bg:setAltas("fight_atlas_3", "xui_skzb_labe_04");
		self:showFightEff(true);
	else
		self:showFightEff(false);
		if self:getFightResult(recordId, index) == 1 then
			self.bg:setAltas("fight_atlas_3", "xui_skzb_labe_02");
		else
			self.bg:setAltas("fight_atlas_3", "xui_skzb_labe_03");
		end
	end
end

function Lua_FihgtUnitStateItem:getFightResult(recordId, index)
	local msg = DataCenter.fightData:getFightResult(recordId);
	if msg and msg.hurt_collect and msg.hurt_collect.hurt_collect_list then
		local list = msg.hurt_collect.hurt_collect_list;
		for i = 1, #list do
			if list[i].rotation == index then
				return list[i].aod_win;
			end
		end
	end
	return 0;
end

function Lua_FihgtUnitStateItem:showFightEff(value)
	if value then
		if self.fightEff == nil then
			self.fightEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_jijian", "ui_jijian", 0, 0);
		end
		self.fightEff:setEnable(true);
	else
		if self.fightEff then
			self.fightEff:setEnable(false);
		end
	end
end