Lua_KunXuHolyLandStartFightPanel = class("Lua_KunXuHolyLandStartFightPanel", Lua_DisplayObject);
function Lua_KunXuHolyLandStartFightPanel:ctor(p)
	self:superCall("ctor", p, "KunXuHolyLandStartFightPanel_skin");
end

function Lua_KunXuHolyLandStartFightPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.panelBg.clickScale = false;
	self.panelBg.clickSound = nil;
	self.panelBg:SetDimensions(720, 1800);
	self.panelBg:addClickFuntion(self, self.onMaskClick);

	self.leftMonsterNum = Lua_NumberImage.new(self.leftMonsterObj);
	self.leftMonsterNum:setLocation(-3, -120, 0);
	self.leftMonsterNum.pivot = 0;
	self.leftMonsterNum.numOffsetX = -4;
	self.leftMonsterNum.numAtlas = "number";
	self.leftMonsterNum.firstStr = "xui_zl1_number_10";
	self.leftMonsterNum.preStr = "xui_zl1_number_0";

	self.rightMonsterNum = Lua_NumberImage.new(self.rightMonsterObj);
	self.rightMonsterNum:setLocation(-19, -120, 0);
	self.rightMonsterNum.pivot = 0;
	self.rightMonsterNum.numOffsetX = -4;
	self.rightMonsterNum.numAtlas = "number";
	self.rightMonsterNum.firstStr = "xui_zl1_number_10";
	self.rightMonsterNum.preStr = "xui_zl1_number_0";

	self.leftPlayerNum = Lua_NumberImage.new(self.leftPlayerObj);
	self.leftPlayerNum:setLocation(-23, -124, 0);
	self.leftPlayerNum.pivot = 0;
	self.leftPlayerNum.numOffsetX = -4;
	self.leftPlayerNum.numAtlas = "number";
	self.leftPlayerNum.firstStr = "xui_zl1_number_10";
	self.leftPlayerNum.preStr = "xui_zl1_number_0";

	self.rightPlayerNum = Lua_NumberImage.new(self.rightPlayerObj);
	self.rightPlayerNum:setLocation(19, -124, 0);
	self.rightPlayerNum.pivot = 0;
	self.rightPlayerNum.numOffsetX = -4;
	self.rightPlayerNum.numAtlas = "number";
	self.rightPlayerNum.firstStr = "xui_zl1_number_10";
	self.rightPlayerNum.preStr = "xui_zl1_number_0";

	self:updateMonsterInfo();
	self:updateHeroInfo();
	Lua_CommonUtil.delayCall(DataCenter.kunXuHolyLandUtil.startFightTime, self, self.hide);
end

function Lua_KunXuHolyLandStartFightPanel:dispose()
	if self.leftMonsterNum ~=nil then
		self.leftMonsterNum:dispose();
		self.leftMonsterNum = nil;
	end
	if self.rightMonsterNum ~=nil then
		self.rightMonsterNum:dispose();
		self.rightMonsterNum = nil;
	end
	if self.leftPlayerNum ~=nil then
		self.leftPlayerNum:dispose();
		self.leftPlayerNum = nil;
	end
	if self.rightPlayerNum ~=nil then
		self.rightPlayerNum:dispose();
		self.rightPlayerNum = nil;
	end
	self:superCall("dispose");
end

function Lua_KunXuHolyLandStartFightPanel:onMaskClick(go)

end

function Lua_KunXuHolyLandStartFightPanel:updateHeroInfo()
 	local leftPath, rightPath;
 	local leftForce, leftHeroId, rightForce, rightHeroId = DataCenter.kunXuHolyLandData:getHeroInfo();

 	self.leftPlayerNum.num = leftForce;
 	self.rightPlayerNum.num = rightForce;
 	local heroVo = DataCenter.heroData:getItemByUniqueId(leftHeroId);
 	if heroVo ~= nil then
 		leftPath = heroVo.heroRolePath;
 	end

 	heroVo = DataCenter.heroData:getItemByUniqueId(rightHeroId);
 	if heroVo ~= nil then
 		rightPath = heroVo.heroRolePath;
 	end
 	self.leftPlayImg:setUrl(leftPath);
 	self.rightPlayImg:setUrl(rightPath);
end

function Lua_KunXuHolyLandStartFightPanel:updateMonsterInfo()
	self.levelId = DataCenter.kunXuHolyLandData.openFightId;
	local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	if levelInfo == nil then
		return;
	end
	local monsterList = levelInfo:getMonsterModel();

	local leftPath;
	local rightPath;
	local leftMonsterId = monsterList[1].monsterId;
	local rightMonsterId = monsterList[2].monsterId;
	local cfgData = Lua_MonsterConfigData.getMonsterConfig(leftMonsterId);
    if cfgData ~= nil then
    	leftPath = cfgData.heroVo.heroRolePath;
    end
	cfgData = Lua_MonsterConfigData.getMonsterConfig(rightMonsterId);
	if cfgData ~= nil then
		rightPath = cfgData.heroVo.heroRolePath;
	end
	self.leftMonsterImg:setUrl(leftPath);
	self.rightMonsterImg:setUrl(rightPath);

 	self.leftMonsterNum.num = monsterList[1].force;
 	self.rightMonsterNum.num = monsterList[2].force;
end