--战斗队列
Lua_FightQueueWindow = class("Lua_FightQueueWindow", Lua_Window)
function Lua_FightQueueWindow:ctor()
	self:superCall("ctor")
	self.windowName = "Lua_FightQueueWindow"
	self.skinName = "FightQueueWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_FightQueueWindow:buildShowItem()
	self:superCall("buildShowItem")
	self:addLuaEvent("FIGHTPLAY_ROTATION_CHANGE", self, self.updateData)
	self.lineupArr = Array()

	self.btnInfo = Array()
	self.btnInfo:add(202984)
	self.btnInfo:add(202985)

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal)
	self.buttonList:setLocation(0, -222, 0)
	self.buttonList:setButtonCell(Lua_CommonButtonItem2)
	self.buttonList:setButtonItem(160, 67)
	self.buttonList:setClickCallBack(self, self.onButtonClick)
	self.buttonList:setData(self.btnInfo)
end

function Lua_FightQueueWindow:dispose()
	if self.lineupArr then
		self.lineupArr:dispose()
		self.lineupArr:clear()
		self.lineupArr = nil
	end
	if self.btnList then
		self.btnList:dispose()
		self.btnList = nil
	end
	if self.btnInfo then
		self.btnInfo:clear()
		self.btnInfo = nil
	end
	self:superCall("dispose")
end

function Lua_FightQueueWindow:showWin(param)
	self:superCall("showWin", param)
	local vo = DataCenter.fightData:getRecordVoById(param)
	local player = DataCenter.fightData:getFightPlayerById(param)
	if vo == nil or player == nil or player.isPlayEnd == true then
		self:hide()
		return
	end
	self.buttonList:setSelected(1)
end

-- attackerTeamIdx -- 攻方分队索引
-- defenderTeamIdx -- 守方分队索引
function Lua_FightQueueWindow:onButtonClick(index, data)
	self.selectedIdx = index
	self:updateData()
end

function Lua_FightQueueWindow:updateData()
	local vo = DataCenter.fightData:getRecordVoById(self.showData)
	local player = DataCenter.fightData:getFightPlayerById(self.showData)
	local list
	if self.selectedIdx == 1 then
		list = vo.attacker.lineup
	else
		list = vo.defender.lineup
	end
	local dataLen = #list
	local len = self.lineupArr:getSize()
	local maxLen = dataLen > len and dataLen or len
	local item
	for i = 1, maxLen do
		item = self.lineupArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item == nil then
				item = Lua_FightQueueItem.new(self.content)
				self.lineupArr:add(item)
			else
				item:setEnable(true)
			end
			item:setLocation(0, 85.5 - (i - 1) * 169, 0)
			if self.selectedIdx == 1 then
				item:setData(list[i], i, player.attackerTeamIdx)
			else
				item:setData(list[i], i, player.defenderTeamIdx)
			end
		end
	end
end










Lua_FightQueueItem = class("Lua_FightQueueItem", Lua_DisplayObject)
function Lua_FightQueueItem:ctor(p)
	self:superCall("ctor", p, "FightQueueItem_skin")
end

function Lua_FightQueueItem:buildShowItem()
	self:superCall("buildShowItem")
	self.heroArr = Array()
	self.checInfo:addClickFuntion(self, self.onCheckInfo)
end

function Lua_FightQueueItem:dispose()
	if self.heroArr then
		self.heroArr:dispose()
		self.heroArr:clear()
		self.heroArr = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_FightQueueItem:setData(data, index, curIdx)
	self.data = data
	local list = data.hero_list
	local dataLen = #list
	local len = self.heroArr:getSize()
	local maxLen = dataLen > len and dataLen or len
	local item
	local tvo
	for i = 1, maxLen do
		item = self.heroArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item == nil then
				item = Lua_ItemIcon.new(self.content)
				item:setCanClick(true)
				self.heroArr:add(item)
			else
				item:setEnable(true)
			end
			item:setScale(0.7, 0.7, 1)
			item:setLocation(-238 + (i - 1) * 95, -19, 0)
			tvo = Lua_ToolVo.createToolVo(list[i].hero_id)
			tvo:fromServer(list[i])
			item:setData(tvo)
		end
	end

	self.forceText.text = data.force
	self.titleText.text = LanUtil.formateStr(202989, tostring(index))
	if index == curIdx then
		self.stateText:setLangValue(202988)
	else
		if index == 1 and curIdx and curIdx > 1 then
			self.stateText:setLangValue(202986)
		else
			self.stateText:setLangValue(202987)
		end
	end
end

function Lua_FightQueueItem:onCheckInfo(go)
	Lua_WindowUtil.openWin("Lua_HeroGridViewWindow", Lua_WinParam.ACTION_OPEN, { posX = 105, posY = -5, showHero = self.data.hero_list })
end