-- 公会对抗 挑战BOSS结算界面
checkRequire("Lua_FightResultBaseWindow");
Lua_AllianceDuelBossResultWindow = class("Lua_AllianceDuelBossResultWindow", Lua_FightResultBaseWindow);
function Lua_AllianceDuelBossResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllianceDuelBossResultWindow";
	self.skinName = "AllianceDuelBossResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";

	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_AllianceDuelBossResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_AllianceDuelBossResultWindow:dispose()
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_AllianceDuelBossResultWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;

	local allianceUtil = DataCenter.allianceUtil;
	self.hurtTxt.text = allianceUtil:transNumber(param.fight_hurt, false);
	self.valueTxt.text = LanUtil.formateStr("<color=#f8ef8a>{1}</color><color=#65be7e> ({2})</color>", allianceUtil:transNumber(param.combat_total_hurt, false), allianceUtil:transNumber(param.fight_hurt));

	self.newIcon:setEnable(param.is_new_hurt == 1);

	self:updateRewards(param.item_list);

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteInfo();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteReward();
end

function Lua_AllianceDuelBossResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self.rewardSp:setEnable(false);
		self:clearRewardList();
		return;
	end
	
	self.rewardSp:setEnable(true);

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 540, 232.5, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 4);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 155, Lua_AxisDefine.Horizontal);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 1);
		end
		self.rewardList:setLocation(0, -290, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_AllianceDuelBossResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_AllianceDuelBossResultWindow:onCancelBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1111, true, false);
end