-- 公会对抗 抢夺成功界面
checkRequire("Lua_FightResultBaseWindow");
Lua_AllianceDuelWinWindow = class("Lua_AllianceDuelWinWindow", Lua_FightResultBaseWindow);
function Lua_AllianceDuelWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllianceDuelWinWindow";
	self.skinName = "AllianceDuelWinWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_ty_qdsl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";

	self.bIsWin = nil;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_AllianceDuelWinWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.uiEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_qdsl_01", "ui_ty_qdsl_01", 0, 205)

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setLocation(-145, -50, 0);
	self.avatarItem:setScale(0.7, 0.7);

	self.otherAvatarItem = Lua_AvatarItem.new(self.content);
	self.otherAvatarItem:setLocation(142, -50, 0);
	self.otherAvatarItem:setScale(0.7, 0.7);

	self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_AllianceDuelWinWindow:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	if self.otherAvatarItem ~= nil then
		self.otherAvatarItem:dispose();
		self.otherAvatarItem = nil;
	end
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_AllianceDuelWinWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;

	local allianceUtil = DataCenter.allianceUtil;
	local roleInfo = param.league_combat_att_info;
	self.avatarItem:setRoleDressUp(roleInfo.dress_info, false, 0.9);
	self.avatarItem:setAvatarBg("common_altas_3", "xui_common_widget_019");
	self.myNameTxt.text = roleInfo.name;
	self.myHurtTxt.text = allianceUtil:transNumber(roleInfo.hurt_change);

	roleInfo = param.league_combat_def_info;
	self.otherAvatarItem:setRoleDressUp(roleInfo.dress_info, false, 0.9);
	self.otherAvatarItem:setAvatarBg("common_altas_3", "xui_common_widget_019");
	self.otherNameTxt.text = roleInfo.name;
	self.otherHurtTxt.text = allianceUtil:transNumber(roleInfo.hurt_change);

	self.killTxt.text = LanUtil.formateStr(201304, param.kill_hero_num);

	self:updateRewards(param.item_list);

	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteInfo();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteReward();
	Lua_ProxyManager.getProxy("Lua_AllianceProxy"):sLeagueCompeteRank(2);
end

function Lua_AllianceDuelWinWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self.rewardSp:setEnable(false);
		self:clearRewardList();
		return;
	end
	
	self.rewardSp:setEnable(true);

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 540, 232.5, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 4);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 155, Lua_AxisDefine.Horizontal);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 1);
		end
		self.rewardList:setLocation(0, -390, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_AllianceDuelWinWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_AllianceDuelWinWindow:onCancelBtnClick()
	DataCenter.funcPathUtil:gotoFunction(1111, true, false);
end