-- 公会战
checkRequire("Lua_FightResultBaseWindow");
Lua_AllianceFightFailResultWindow = class("Lua_AllianceFightFailResultWindow", Lua_FightResultBaseWindow);
function Lua_AllianceFightFailResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllianceFightFailResultWindow";
	self.skinName = "AllianceFightFailResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D)
	self.openSound = "fight_win_01"

	self.bIsWin = false;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_AllianceFightFailResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
	self.btnSure:addClickFuntion(self, self.hide);
end

function Lua_AllianceFightFailResultWindow:dispose()
	self:superCall("dispose");
end

function Lua_AllianceFightFailResultWindow:showWin(param)
	self:superCall("showWin", param);

	local fightNameStr;
	local total_star = param.total_star or 0;
	if total_star <= 0 then
		fightNameStr = LanUtil.getValue(785072);
	else
		fightNameStr = LanUtil.getValue(785073);
	end

	self.nameText.text = fightNameStr;
	self.scoreTxt_2.text = LanUtil.formateStr(785074, param.score);
	self:updateFuncIcons("showObject_2");
end

function Lua_AllianceFightFailResultWindow:onBtnBackClick(go)
	if self.clickTime and getTime() - self.clickTime < 1 then
		OperateAlert.showLangValue(10031);
		return;
	end
	self.clickTime = getTime();	
	
	DataCenter.funcPathUtil:gotoFunction(1175, true, false);
end

function Lua_AllianceFightFailResultWindow:updateFuncIcons(goName)
	self.guideItemPathStr = goName;
	local configData = Lua_FightTemplateConfigData.getConfigData(self.templateId);
	local list = configData.failOpenIcons;
	if list == nil or #list <= 0 then
		self:removeFuncIcons();
	else
		if self.iconsList == nil then
			self.iconsList = Array();
		end
		local len = self.iconsList:getSize();
		local num = #list - len;

		local go = self[goName] or self.content
		while (num > 0) do
			item = Lua_IconSkipItem.new(go);
			self.iconsList:add(item);
			num = num - 1;
		end

		while (num < 0) do
			item = self.iconsList:remove(1);
			item:dispose();
			num = num + 1;
		end

		len = self.iconsList:getSize();
		local space = 140;
		local w;
		local posX;
		local posY;
		for i = 1, len do
			item = self.iconsList[i];
			item:setClick(self, self.onIconSkip);
			item:setData(list[i]);

			w = -(space * len) / 2 + space / 2;
			posX = ((i - 1) % len) * space + w;
			posY = -280 + Mathf.Floor((i - 1) / len) * -space;
			item:setLocation(posX, posY, 0);
		end
	end

	if DataCenter.funcOpenData:isOpened(10002) then
		self:activeGuideId(); -- 引导用
	end
end