-- 公会战
checkRequire("Lua_FightResultBaseWindow");
Lua_AllianceFightWinResultWindow = class("Lua_AllianceFightWinResultWindow", Lua_FightResultBaseWindow);
function Lua_AllianceFightWinResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_AllianceFightWinResultWindow";
	self.skinName = "AllianceFightWinResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D)
	self.openSound = "fight_win_01"

	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_AllianceFightWinResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnLeft:addClickFuntion(self, self.onBtnRightClick);
	self.btnRight:addClickFuntion(self, self.hide);
end

function Lua_AllianceFightWinResultWindow:dispose()
	self:clearRewardList();
	if self.starSps ~= nil then
		local item;
		for i = 1, #self.starSps do
			item = self.starSps[i]
			if item ~= nil then
				item:dispose();
				item = nil;
			end
		end
		self.starSps = nil;
	end
	self:superCall("dispose");
end

function Lua_AllianceFightWinResultWindow:showWin(param)
	self:superCall("showWin", param);

	local posY;
	local count;
	local diffStr;
	local fightNameStr;
	local total_star = param.total_star or 0;
	local scoreNum = param.score;
	if total_star <= 0 then
		posY = -49;
		count = 0;
		fightNameStr = LanUtil.getValue(785072);
	else
		posY = -76;
		count = total_star;
		diffStr = LanUtil.getValue(785033);
		fightNameStr = LanUtil.getValue(785073);
	end

	self.diffTxt.text = diffStr;
	self.nameText.text = fightNameStr;
	self.scoreTxt_1:setLocation(-12, posY);
	self.scoreTxt_2:setLocation(0, posY);
	self.scoreTxt_2.text = LanUtil.formateStr(785074, scoreNum);

	self:updateStar(count);
	self:updateRewards(param.item_list);
end

function Lua_AllianceFightWinResultWindow:updateStar(count)
	count = count or 0; 
	if self.starSps == nil then
		self.starSps = {};
	end

	local id;
	local item;
	local posX;
	local distance = 47;
	local startX = -4;
	for i = 1, count do
		item = self.starSps[i];
		if item == nil then
			item = UICreate.createUIAtlasImage(self.showObject_2, "common_altas_4", "xui_common_label_15", -4, -28, 44, 44);
			-- item.anchorValue = 1;
			self.starSps[i] = item;
		end

		posX = startX + (i - 1) * distance;
		item:setLocation(posX, -28);
		item:setEnable(true);
	end

	if count < #self.starSps then
		for i = count + 1, #self.starSps do
			item = self.starSps[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_AllianceFightWinResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardBg:SetDimensions(720, 266);
			self.rewardList = Lua_DragList.new(self.showObject_3, 556, 240, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 160, 4);
		else
			self.rewardBg:SetDimensions(720, 176);
			self.rewardList = Lua_DragList.new(self.showObject_3, len * 124 + (len - 1) * 20, 160, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 160, 4);
		end
		self.rewardList:setCellSpacing(20, 0);
		self.rewardList:setRectPivot(1)
		self.rewardList:setLocation(0, -211, 0);
		self.rewardList.tweenId = 2007;
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_AllianceFightWinResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_AllianceFightWinResultWindow:onBtnRightClick(go)
	if self.clickTime and getTime() - self.clickTime < 1 then
		OperateAlert.showLangValue(10031);
		return;
	end
	self.clickTime = getTime();	
	
	DataCenter.funcPathUtil:gotoFunction(1175, true, false);
end