-- BOSS挑战结算界面
checkRequire("Lua_FightResultBaseWindow");
Lua_BossChallengeFightResultWindow = class("Lua_BossChallengeFightResultWindow", Lua_FightResultBaseWindow);
function Lua_BossChallengeFightResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_BossChallengeFightResultWindow";
	self.skinName = "BossChallengeFightResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";
	
	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_BossChallengeFightResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.rewardBtn:addClickFuntion(self, self.onRewardClick)
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
	self.btnConfirm:addClickFuntion(self, self.hide);
end

-- 80102003
function Lua_BossChallengeFightResultWindow:showWin(param)
	self:superCall("showWin", param);

	local vo = DataCenter.backstageActData:getActVoByIdx(param.stage_id);
	self.nameText_2.text = vo.title;

	local list = param.hurt_collect.hurt_collect_list;
	if list == nil then
		return;
	end

	if param.is_new_hurt == 1 then
		self.hurtIcon:setAltas("fight_atlas_2", "xui_zd_word_11");
	else
		self.hurtIcon:setAltas("fight_atlas_2", "xui_zd_word_10");
	end

	local idx = -1;
	local maxRot = -1;
	for i = 1, #list do
		if list[i].rotation > maxRot then
			maxRot = list[i].rotation;
			idx = i;
		end
	end
	local defendList = list[idx].defender_hurt_collect;
	local bossHurt = self:getBossHurt(defendList); -- param.fight_hurt
	local index, maxHurt, prevValue, isFinally = DataCenter.bossChallengeData:getFightShowInfo(bossHurt);
	local isMax = index == nil;
	self.stepText.text = isMax and "Max" or "x"..index;
	self.hurtBar:setMaxValue(maxHurt);
	self.hurtBar:setValue(bossHurt);
	self.hurtBar:setText(isMax and bossHurt or bossHurt.."/"..maxHurt);

	local maxHurtValue = tonumber(tostring(param.max_hurt));
	self.maxValueTxt.text = LanUtil.formateStr(640017, maxHurtValue);

	local stageInfo = DataCenter.bossChallengeData.daily_hurt_reward;
	local nextStageIdx = DataCenter.bossChallengeData.nextStageIdx;
	local isFinish = stageInfo[#stageInfo].is_finish == 0;
	if isFinish then
		self.targetValueTxt.text = LanUtil.formateStr(640018, stageInfo[nextStageIdx].hurt);
	else
		self.targetValueTxt:setLangValue(640020);
	end
	self.willGetIcon:setEnable(isFinish);
end

function Lua_BossChallengeFightResultWindow:getBossHurt(list)
	if list ~= nil then
		for i = 1, #list do
			if list[i].type == 5 then
				return tonumber(list[i].bear_hurt);
			end
		end
	end
	return 0;
end

-- 下一阶段奖励
function Lua_BossChallengeFightResultWindow:onRewardClick(go)
	self:onCancelTimer();
	Lua_WindowUtil.openWin("Lua_BossChallengeShowRewardWindow", Lua_WinParam.ACTION_OPEN, 2);
end

function Lua_BossChallengeFightResultWindow:onBtnBackClick(go)
	print("活动索引id", self.showData.stage_id);
	local vo = DataCenter.backstageActData:getActVoByIdx(self.showData.stage_id);
	if vo.residueTime > 0 then
		Lua_WindowUtil.openWin(vo.main_win, Lua_WinParam.ACTION_OPEN, vo);
	else
		OperateAlert.showLangValue(640019);
	end
	self:hide();
end

function Lua_BossChallengeFightResultWindow:dispose()
	self:superCall("dispose");
end