checkRequire("Lua_ChaosCopyFightWinResultWindow");
Lua_ChaosCopyFightFailResultWindow = class("Lua_ChaosCopyFightFailResultWindow", Lua_ChaosCopyFightWinResultWindow)
function Lua_ChaosCopyFightFailResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChaosCopyFightFailResultWindow";
	self.skinName = "ChaosCopyFightResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_lose_01";

	self.bIsWin = false;
	self.bIsShowHurtBtn = true;
	self.bIsShowCountTime = true;
end

function Lua_ChaosCopyFightFailResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.condList = Array();

	self.line_1 = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_line_010", 167, 717, 0, 0);
	self.line_1.anchorValue = 7;

	self.line_2 = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_line_010", -167, 717, 0, 0);
	self.line_2.anchorValue = 7;
	self.line_2:setScale(-1, 1, 1);

	self.winLabel = UICreate.createLabel(self.content, nil, 0, 717, 100, 31, 32);
	self.winLabel.anchorValue = 7;
	self.winLabel.pivotValue = 4
	self.winLabel.alignmentValue = 4;
	self.winLabel.fontName = Lua_MyUISettings.huakangFontName;
	self.winLabel.colorStr = Lua_ColorDefine.transColor("FFFFFF");
	self.winLabel.horizontalOverflowValue = 1;
	self.winLabel.verticalOverflowValue = 1;
	self.winLabel.effectStyle = 2;
	self.winLabel.effectColorStr = Lua_ColorDefine.transColor("000000");
	self.winLabel:setEffectDistance(2, 2);
	self.winLabel:setLangValue(796040);
end

function Lua_ChaosCopyFightFailResultWindow:dispose()
	if self.condList then
		self.condList:dispose();
		self.condList:clear();
		self.condList = nil;
	end
	self:superCall("dispose");
end

function Lua_ChaosCopyFightFailResultWindow:updateConds(condList)
	local stateDic = {};
	for i,v in ipairs(condList) do
		stateDic[tonumber(v.key)] = tonumber(v.value);
	end

	local config = DataCenter.chaosCopyUtil:getStageConfig(self.showData.stage_id);
	if config == nil then
		return;
	end
	local item;
	for i,v in ipairs(config.win_conds) do
		item = self.condList[i];
		if item == nil then
			item = Lua_ChaosCopyFightResultCondItem.new(self.showObject_2);
			self.condList:add(item);
		end
		item:setRectAnchor(7);
		item:setLocation(-85, 665 - (i - 1) * 45, 0);
		item:setData(v, stateDic[v[1]]);
	end
end

function Lua_ChaosCopyFightFailResultWindow:onBackClick(go)
	if Lua_WindowUtil.isWindowShowing("Lua_ChaosCopyWindow") then
		self:hide();
	else
		DataCenter.funcPathUtil:gotoFunction(1195, true, false);
	end
end

function Lua_ChaosCopyFightFailResultWindow:onSureClick(go)
	self:hide();
end










Lua_ChaosCopyFightResultCondItem = class("Lua_ChaosCopyFightResultCondItem", Lua_DisplayObject)
function Lua_ChaosCopyFightResultCondItem:buildShowItem()
	self:superCall("buildShowItem");

	self.stateIcon = UICreate.createUIAtlasImage(self.content, "chaos_copy_atlas", "xui_hdxj_label_09", 0, 0, 0, 0);

	self.desText = UICreate.createLabel(self.content, nil, 25, 0, 100, 31, 26);
	self.desText.pivotValue = 3;
	self.desText.alignmentValue = 3;
	self.desText.horizontalOverflowValue = 1;
	self.desText.verticalOverflowValue = 0;
	self.desText.colorStr = Lua_ColorDefine.transColorStr("ACACAC");
	self.desText.effectStyle = 2;
	self.desText.effectColorStr = Lua_ColorDefine.transColor("000000");
	self.desText:setEffectDistance(2, 2);
end

function Lua_ChaosCopyFightResultCondItem:dispose()
	self:superCall("dispose");
end

function Lua_ChaosCopyFightResultCondItem:setData(data, state)
	local str = nil;
	if data[1] == 1 then
		str = LanUtil.getValue(796030);
	elseif data[1] == 2 then
		str = LanUtil.formateStr(796031, tostring(data[2]));
	elseif data[1] == 3 then
		str = LanUtil.formateStr(796032, tostring(data[2]));
	elseif data[1] == 4 then
		str = LanUtil.formateStr(796033, tostring(data[2] * 100));
	end
	self.desText.text = str;

	if state == 1 then
		self.stateIcon:setAltas("chaos_copy_atlas", "xui_hdxj_label_08");
		self.desText.colorStr = Lua_ColorDefine.transColorStr("6DDB62");
	else
		self.stateIcon:setAltas("chaos_copy_atlas", "xui_hdxj_label_09");
		self.desText.colorStr = Lua_ColorDefine.transColorStr("ACACAC");
	end
end