checkRequire("Lua_FightResultBaseWindow");
Lua_ClimbTowerFightFailWindow = class("Lua_ClimbTowerFightFailWindow", Lua_FightResultBaseWindow);
function Lua_ClimbTowerFightFailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ClimbTowerFightFailWindow";
	self.skinName = "ClimbTowerFightFailWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_lose_01";

	self.bIsWin = false;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_ClimbTowerFightFailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnLeft:addClickFuntion(self, self.onReturn);
	self.btnRight:addClickFuntion(self, self.hide);
end

function Lua_ClimbTowerFightFailWindow:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ClimbTowerFightFailWindow:showWin(param)
	self:superCall("showWin", param);

	self.data = DataCenter.climbTowerUtil:getTowerConfig(param.stage_id);
	local vo = DataCenter.climbTowerData:getTowerVoById(self.data.index);
	self.nameText.text = LanUtil.StringProfile(vo.name, Lua_SpaceDefine.SPACE, self.data.name);

	self:updateFuncIcons();
end

function Lua_ClimbTowerFightFailWindow:onReturn(go)
	local vo = DataCenter.climbTowerData:getTowerVoById(self.data.index);
	DataCenter.funcPathUtil:gotoFunction(vo.pathId, true, false, "Lua_ClimbTowerEntranceWindow")
end