-- 无尽关卡战斗胜利结算界面
checkRequire("Lua_FightResultBaseWindow");
Lua_EndlessLevelFightResultWindow = class("Lua_EndlessLevelFightResultWindow", Lua_FightResultBaseWindow);
function Lua_EndlessLevelFightResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EndlessLevelFightResultWindow";
	self.skinName = "EndlessLevelFightResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";

	self.showWinBg = false;
	self.showBlackMask = true;
	self.bIsWin = nil; -- 不显示特效
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_EndlessLevelFightResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.hurtBtn.anchorValue = 7;
	self.hurtBtn:setLocation(277, 73);
	self.backBtn:addClickFuntion(self, self.onBackBtnClick)
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_EndlessLevelFightResultWindow:showWin(param)
	self:superCall("showWin", param);

	local historyMaxWave = param.time_space_fight_settle.old_att_rank;
	local historyMaxScore = param.time_space_fight_settle.new_att_rank;
	self.scoreTxt.text = LanUtil.formateStr(779019, param.pass_round, param.total_star);
	self.historyTxt.text = LanUtil.formateStr(779058, historyMaxWave, historyMaxScore);
	self.newRecordIcon:setEnable(param.pass_round > historyMaxWave or param.total_star > historyMaxScore);
	if self.closeText ~= nil then
		self.closeText.anchorValue = 7;
		self.closeText:setLocation(0, 90);
	end
end

function Lua_EndlessLevelFightResultWindow:onBackBtnClick(go)
	-- print("活动索引id", self.showData.stage_id);
	local actVo = DataCenter.backstageActData:getActVoByIdx(self.showData.stage_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end
	Lua_WindowUtil.openWin(actVo.main_win, Lua_WinParam.ACTION_OPEN, actVo);
	self:hide();
end

function Lua_EndlessLevelFightResultWindow:dispose()
	-- Lua_MsgUtil.callFunc("REQUEST_ENDLESSLEVEL_REFRESH_INFO");
	Lua_MsgUtil.callFunc("REQUEST_ENDLESSLEVEL_RANK_INFO", 0);
	DataCenter.endlessLevelData:initInfo();
	self:superCall("dispose");
end