-- 寂灭岛战斗失败结算
checkRequire("Lua_FightResultBaseWindow");
Lua_EquipCopyFightFailWindow = class("Lua_EquipCopyFightFailWindow", Lua_FightResultBaseWindow);
function Lua_EquipCopyFightFailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EquipCopyFightFailWindow";
	self.skinName = "EquipCopyFightFailWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_lose_01";
	
	self.bIsWin = false; -- 是否胜利
	self.bIsShowCountTime = true; -- 是否显示倒计时
	self.bIsShowHurtBtn = true; -- 是否显示伤害统计按钮
end

function Lua_EquipCopyFightFailWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.headInfo = Array();
	DataCenter.equipCopyData.bNextFight = true;

	self.backBtn:addClickFuntion(self, self.onBackBtnClick); -- 返回玩法
	self.subBtn:addClickFuntion(self, self.hide); -- 确定
end

function Lua_EquipCopyFightFailWindow:showWin(param)
	self:superCall("showWin",param);
	self.closeText.anchor = Lua_WindowUtil.getAnchor(7);
	self.closeText:setLocation(0,123,0);
	self:showDrawInfo(); -- 头像展示
end

function Lua_EquipCopyFightFailWindow:showDrawInfo()
	local list = self.showData.hurt_collect_list; -- 伤害统计信息
	if list == nil then
		return;
	end

	local length = 0;
	for i = 1, #list do
		if list[i].win_type == 2 then
			length = length + 1;
		end
	end

	for i = 1, self.headInfo:getSize() do
		self.headInfo[i]:setEnable(false);
	end

	local item;
	local width = 159;
	local index = 0;
	for i = 1, #list do
		if list[i].win_type == 2 then
			index = index + 1;
			item = self.headInfo[index];
			if item == nil then
				item = Lua_ShowFailHeadItem.new(self.content);
				item:setRectAnchor(7);
				self.headInfo:add(item);
			end
			item:setData(list[i]);
			item:setLocation((1 - length) * width / 2 + (index - 1) * width, 469);
			item:setEnable(true);
		end
	end
end

-- 返回玩法
function Lua_EquipCopyFightFailWindow:onBackBtnClick()
	if self.showData.template_id == DataCenter.equipCopyUtil.single_template_id then -- 单人
		DataCenter.funcPathUtil:gotoFunction(1037, true);
	elseif self.showData.template_id == DataCenter.equipCopyUtil.more_template_id then -- 组队
		local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_COPY_MORE);
		if recordId == nil or recordId == 0 or recordId == self.recordId then
			self:onOpenWindow();
		else -- 已经开始了战斗
			DataCenter.fightData:showFightToStageByRid(recordId);
		end
	end
	self:hide();
end

function Lua_EquipCopyFightFailWindow:onOpenWindow()
	if Lua_WindowUtil.isWindowShowing("Lua_EquipCopyWindow") then
			local index = 1;--打开组队大厅
		if (DataCenter.equipCopyData.reward_times > 0 or DataCenter.equipCopyData.help_times >0) and
		 DataCenter.equipCopyData.team_id ~= 0  then-- 次数充足/没有被踢出队伍--打开组队界面
			index = 2;
		end
		Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_OPEN, index);
	else
		DataCenter.funcPathUtil:gotoFunction(1117, true);--组队
	end
end

function Lua_EquipCopyFightFailWindow:onBtnHurtClick()
	Lua_WindowUtil.openWin("Lua_FightMoreHurtWindow", Lua_WinParam.ACTION_OPEN, self.showData.hurt_collect_list);
end

function Lua_EquipCopyFightFailWindow:dispose()
	if self.headInfo ~= nil then
		self.headInfo:dispose()
		self.headInfo:clear()
		self.headInfo = nil;
	end
	if DataCenter.equipCopyData.team_id ~= 0 then
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sTeam();
	end

	self:superCall("dispose");
end










-- 失败玩家头像
Lua_ShowFailHeadItem = class("Lua_ShowFailHeadItem", Lua_DisplayObject);
function Lua_ShowFailHeadItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ShowFailHeadItem:buildShowItem()
	self:superCall("buildShowItem");

	self.palyerHead = Lua_AvatarItem.new(self.content);

	self.playerName = UICreate.createLabel(self.content, "", 0, -74, 100, 24, 24);
	self.playerName.colorStr = Lua_ColorDefine.transColorStr("F4F0ED");
	self.playerName.pivot = UIUtils.Pivot.Center;
	self.playerName.alignmentValue = 4;
	self.playerName.horizontalOverflowValue = 1;
end

function Lua_ShowFailHeadItem:setData(data)
	data = data.hurt_collect_list[1];
	self.palyerHead:setRoleDressUp(data.attacker.dress_info);
	self.palyerHead:setCanClick(true);
	self.palyerHead:setRoleLevel(data.attacker.level);
	self.playerName.text = data.attacker.name;
end

function Lua_ShowFailHeadItem:dispose()
	if self.palyerHead ~= nil then
		self.palyerHead:dispose();
		self.palyerHead = nil;
	end
	if self.playerName ~= nil then
		self.playerName:dispose();
		self.playerName = nil;
	end

	self:superCall("dispose");
end