-- 寂灭岛战斗胜利结算
checkRequire("Lua_FightResultBaseWindow");
Lua_EquipCopyFightWinWindow = class("Lua_EquipCopyFightWinWindow", Lua_FightResultBaseWindow);
function Lua_EquipCopyFightWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EquipCopyFightWinWindow";
	self.skinName = "EquipCopyFightWinWindow_skin";
	self.winBgPath = "/images/equipcopy/xui_jmd_bg_003.jpg";

	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self.openSound = "fight_win_01";

	self.bIsShowCountTime = true; -- 是否显示倒计时
end

function Lua_EquipCopyFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.resultIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 35, 321, 0, 0);
	self.resultIcon.anchor = Lua_WindowUtil.getAnchor(4);
	self.resultIcon:setAltas("equipcopy_atlas_2", "xui_jmd_title_001");
	self.resultIcon:resetSize();
	self.resultIcon:setLocation(-31.5, 587);

	self.backBtn:addClickFuntion(self, self.onBackBtnClick); -- 返回玩法
	self.subBtn:addClickFuntion(self, self.onSureClick); -- 确定
	self.hurtBtn:addClickFuntion(self, self.onHurtBtnClick); -- 伤害统计

	self:addLuaEvent("ON_CARD_ITEM", self, self.onCardItem); -- 点击翻牌
	self:addLuaEvent("ON_HARVEST_ITEM_OVER", self, self.onHarvestItemOver); -- 点击翻牌结束
	self:addLuaEvent("UPDATE_SINGLE_OPEN_CARD", self, self.updateSingleOpenCard); -- 单人 点击翻牌奖励
	self:addLuaEvent("UPDATE_MORE_OPEN_CARD", self, self.updateMoveOpenCard); -- 组队 点击单个翻牌奖励
	self:addLuaEvent("UPDATE_REST_MORE_OPEN_CARD", self, self.updateRestMoveOpenCard); -- 组队 剩余翻牌奖励展示
end

-- msg 80201019
function Lua_EquipCopyFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	self:showFightInfo();

	DataCenter.equipCopyData.reward_times = param.left_reward_times; -- 奖励次数
	DataCenter.equipCopyData.extra_reward_times = param.left_help_reward_times; -- 协助奖励次数
	DataCenter.equipCopyData.help_times = param.left_help_times; -- 协助次数
	Lua_MsgUtil.callFunc("UPDATE_EQUIPCOPY_TEAM_REWARD_COUNT");

	if self.closeText ~= nil then
		self.closeText.anchor = Lua_WindowUtil.getAnchor(7);
		self.closeText.colorStr = Lua_ColorDefine.transColorStr("CAC5BA");
		self.closeText:setLocation(0,50,0);
	end
	-- 首通排行红点显示
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sFirstPassRankInfo();
end

function Lua_EquipCopyFightWinWindow:onScreenResize()
	self:superCall("onScreenResize");
end

function Lua_EquipCopyFightWinWindow:showFightInfo()
	-- print("80201019", self.showData.template_id, self.showData.fight_grade, self.showData.boss_difficulty);
	self.showIcon:setAltas("equipcopy_atlas_2","xui_jmd_label_"..6-self.showData.fight_grade);
	self.showIcon:resetSize();

	self.showNumTxt.text = LanUtil.formateStr(420073, self.showData.total_round);

	-- 1单人 2组队
	local equipCopyData = DataCenter.equipCopyData;
	local equipCopyUtil = DataCenter.equipCopyUtil;
	if self.showData.template_id == equipCopyUtil.single_template_id then
		self.titleTxt.text = LanUtil.formateStr(420074, getConfig("equip_copy", self.showData.boss_camp, "boss_name"));
		self.rewardNumTxt.text = LanUtil.formateStr(420075, self.showData.left_reward_times, equipCopyData.times_limit);
		self:updateGradeInfo(1);
	elseif self.showData.template_id == equipCopyUtil.more_template_id then
		self.titleTxt.text = LanUtil.formateStr(420074, getConfig("equip_copy_more", self.showData.boss_difficulty, "boss_name"));
		if self.showData.left_reward_times > 0 then
			self.rewardNumTxt.text = LanUtil.formateStr(420075, self.showData.left_reward_times, equipCopyUtil.more_reward_limit);
		else
			self.rewardNumTxt.text = LanUtil.formateStr(420077, self.showData.left_help_times, equipCopyUtil.more_extra_limit);
		end
		
		self:updateGradeInfo(2);
	end

	-- -- 协战奖励
	local isTeam = self.showData.template_id == equipCopyUtil.more_template_id;
	-- local isReward = self.showData.left_reward_times <= 0;
	-- local isExtraReward = self.showData.left_help_reward_times > 0;
	-- self.extraRewardTxt:setEnable(isTeam and isReward and isExtraReward);
	-- 不显示协战奖励，改为协战奖励次数
	local count = equipCopyUtil.more_extra_reward_count;
	self.extraRewardTxt.text = LanUtil.formateStr(420076, self.showData.left_help_reward_times, count);
	self.extraRewardTxt:setEnable(isTeam);

	-- 战令奖励
	local bOpened = DataCenter.funcOpenData:isOpened(10262);
	if bOpened then
		if self.showData.war_exp_num > 0 then
			local leftTime = equipCopyUtil.war_exp_reward_num - self.showData.war_exp_num;
			if leftTime >= 0 then
				local itemDic = equipCopyUtil.war_exp_reward_list[self.showData.war_exp_num];
				self.warExpTxt.text = LanUtil.formateStr(420078, self.showData.war_exp_num, spliceIconStrById(itemDic[1]), itemDic[2]);
			else
				self.warExpTxt:setLangValue(420079);
				self.warExpTxt:setLocation(-310, -423, 0);
			end
			self.warExpBg:setEnable(true);
			self.warExpTxt:setEnable(true);
		end
	else
		self.warExpBg:setEnable(false);
		self.warExpTxt:setEnable(false);
	end
	self:updateCardInfo();
end

-- 点击翻牌 1单人 2组队
function Lua_EquipCopyFightWinWindow:onCardItem(index)
	self.onCardIndex = index;
	if self.tag_typev == 1 then
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sSingleOpenCard(index, self.showData.record_id);
	else
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sMoreOpenCard(index);
	end
end

-- 点击翻牌结束在弹窗
function Lua_EquipCopyFightWinWindow:onHarvestItemOver(onCardIndex)
	if self.onCardIndex == onCardIndex then
		self.onCardIndex = nil;
		local list = DataCenter.equipCopyData.openCardRewardInfo;
		if list == nil then
			return
		end
		local tvo;
		local arr = Array();
		if self.tag_typev == 1 then
			for index, v in pairs(list) do
				if index == onCardIndex then
					tvo = Lua_ToolVo.createToolVo(v[1].id, v[1].amount);
					arr:add(tvo);
					break;
				end
			end
		else
			for i=1, #list do
				if list[i].reward_pos == onCardIndex and tonumber(tostring(list[i].member_id)) == DataCenter.roleData.roleId then
					local reward = list[i].reward;
					tvo = Lua_ToolVo.createToolVo(reward[1].id, reward[1].amount);
					arr:add(tvo);
					break;
				end
			end
		end
		if arr:getSize() >= 1 then
			Lua_WindowUtil.openWin("Lua_EquipCopyRewardTipWindow", Lua_WinParam.ACTION_OPEN, arr);
		end
	end
end


-- 单人点击单个翻牌奖励
function Lua_EquipCopyFightWinWindow:updateSingleOpenCard()
	local open_index = DataCenter.equipCopyData.open_index;
	local list = DataCenter.equipCopyData.openCardRewardInfo;
	if list == nil then
		return;
	end

	local len = self.cardInfo:getSize();
	local index;
	for i = 1, len do
		index = self.cardInfo[i].index;
		if list[index] ~= nil then
			self.cardInfo[i]:setItemInfo(list[index]); -- 设置奖励信息
			if index == open_index then
				local avatarId = DataCenter.roleData:getOwnDressUpId(Lua_DressUpDefine.MAINTYPE_HEAD); 
				self.cardInfo[index]:setPlayerInfo({dress_info = {{key = Lua_DressUpDefine.MAINTYPE_HEAD, value = avatarId}}}); -- 设置玩家信息
				self.cardInfo[index]:onStartComplete();
			end
		end
	end
	self:starEffectTime();
end

-- 组队点击单个翻牌奖励
function Lua_EquipCopyFightWinWindow:updateMoveOpenCard()
	local list = DataCenter.equipCopyData.openCardRewardInfo;
	if list == nil then
		return;
	end

	-- 队员信息
	local listDic = {};
	local p_list = self.showData.hurt_collect_list;
	local obj;
	local player_id;
	for i = 1, #p_list do
		obj = p_list[i].hurt_collect_list
		for j = 1, #obj do
			player_id = tonumber(obj[j].attacker.id);
			listDic[player_id] = obj[j].attacker;
		end
	end

	local vo = list[1];
	local index = vo.reward_pos; -- 卡牌位置
	local member_id = tonumber(vo.member_id); -- 成员id
	if self.cardInfo[index] ~= nil then
		self.cardInfo[index]:setPlayerInfo(listDic[member_id]); -- 设置玩家信息
		self.cardInfo[index]:setItemInfo(vo.reward); -- 设置奖励信息
		self.cardInfo[index]:onStartComplete(); -- 开始翻盘effect
	end
end

-- 组队剩余翻牌奖励展示
function Lua_EquipCopyFightWinWindow:updateRestMoveOpenCard()
	local list = DataCenter.equipCopyData.openCardRewardInfo;
	if list == nil then
		return;
	end

	-- 队员信息
	local listDic = {};
	local p_list = self.showData.hurt_collect_list;
	local obj;
	local player_id;
	for i = 1, #p_list do
		obj = p_list[i].hurt_collect_list
		for j = 1, #obj do
			player_id = tonumber(obj[j].attacker.id);
			listDic[player_id] = obj[j].attacker;
		end
	end

	local vo;
	local index; -- 卡牌位置
	local member_id; -- 成员id
	for i = 1, #list do
		vo = list[i];
		index = vo.reward_pos;
		member_id = tonumber(vo.member_id);
		if self.cardInfo[index] ~= nil then
			self.cardInfo[index]:setPlayerInfo(listDic[member_id]); -- 设置玩家信息
			self.cardInfo[index]:setItemInfo(vo.reward); -- 设置奖励信息
			self.cardInfo[index]:onStartComplete();
		end
	end
end

-- 翻牌动画播放计时器
function Lua_EquipCopyFightWinWindow:starEffectTime()
	Lua_CommonUtil.addTimer("showEffectTime", 1, self, self.showEffectTime);
end

-- 翻开未翻盘的卡牌
function Lua_EquipCopyFightWinWindow:showEffectTime()
	-- print("翻开未翻盘的卡牌");
	Lua_CommonUtil.removeTimer(self,self.showEffectTime);
	if self.cardInfo == nil then
		return
	end

	local open_index = DataCenter.equipCopyData.open_index;
	local list = DataCenter.equipCopyData.openCardRewardInfo;
	local len = self.cardInfo:getSize();
	local index;
	for i = 1, len do
		index = self.cardInfo[i].index;
		if list[index] ~= nil and index ~= open_index then
			self.cardInfo[i]:onStartComplete();
		end
	end
end

-- 评分 1单人 2组队
function Lua_EquipCopyFightWinWindow:updateGradeInfo(val)
	self.tag_typev = val;
	local arr;
	if val == 1 then
		arr = DataCenter.equipCopyUtil.singleGradeInfo;
	else
		arr = DataCenter.equipCopyUtil.moreGradeInfo;
	end

	local max_unm = arr[1].num;
	local ratio = self.showBar.width / max_unm;
	self.showBar:setMaxValue(max_unm);
	self.showBar:setValue(max_unm - self.showData.total_round);
	-- print("评分", self.showData.total_round);

	if self.gradeInfo == nil then
		self.gradeInfo = Array();
	end
	for i = 1, self.gradeInfo:getSize() do
		self.gradeInfo[i]:setEnable(false);
	end

	local item;
	for i = 1, arr:getSize() do
		item = self.gradeInfo[i];
		if item == nil then
			item = Lua_EquipCopyGradeItem.new(self.content);
			item:setRectAnchor(4);
			self.gradeInfo:add(item);
		end
		item:setData(arr[i]);
		item:setLocation(-200 + (max_unm - arr[i].num) * ratio, 422);
		item:setEnable(true);
	end
end

-- 卡牌
function Lua_EquipCopyFightWinWindow:updateCardInfo()
	if self.cardInfo == nil then
		self.cardInfo = Array();
	end
	for i = 1, self.cardInfo:getSize() do
		self.cardInfo[i]:setEnable(false);
	end

	local item;
	for i = 1, 6 do
		item = self.cardInfo[i];
		if item == nil then
			item = Lua_EquipCopyCardItem.new(self.content);
			self.cardInfo:add(item);
		end
		item:setType(self.tag_typev); -- 设置类型
		item:setIndex(i); -- 设置所索引
		item:setGrade(self.showData.fight_grade); -- 设置评级
		item:setRewardState(self.showData.is_have_reward == 1); -- 设置是否可领取奖励
		if i <= 3 then
			item:setLocation(-210 + (i - 1) * 210, 191);
		else
			item:setLocation(-210 + (i - 4) * 210, -154);
		end
		item:setEnable(true);
	end
end

-- 返回玩法
function Lua_EquipCopyFightWinWindow:onBackBtnClick()
	if self.tag_typev == 2 then -- 组队
		local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_COPY_MORE);
		if recordId == nil or recordId == 0 or recordId == self.recordId then
			DataCenter.funcPathUtil:gotoFunction(1117, true);--组队
		else -- 已经开始了战斗
			DataCenter.fightData:showFightToStageByRid(recordId);
		end
	else
		Lua_WindowUtil.openWin("Lua_EquipCopyWindow", Lua_WinParam.ACTION_OPEN, {tab_select = self.showData.boss_camp});
	end
	self:hide();
end

function Lua_EquipCopyFightWinWindow:onSureClick()
	if Lua_WindowUtil.isWindowShowing("Lua_EquipCopyWindow") then
		if self.tag_typev == 2 then -- 组队
			DataCenter.funcPathUtil:gotoFunction(1117, true);--组队
		else
			DataCenter.funcPathUtil:gotoFunction(1037);
		end
	end
	self:hide();
end

function Lua_EquipCopyFightWinWindow:onHurtBtnClick()
	if self.tag_typev == 1 then
		Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, self.showData.hurt_collect_list[1]);
	elseif self.tag_typev == 2 then
		Lua_WindowUtil.openWin("Lua_FightMoreHurtWindow", Lua_WinParam.ACTION_OPEN, self.showData.hurt_collect_list);
	end
end

function Lua_EquipCopyFightWinWindow:dispose()
	Lua_CommonUtil.removeTimer(self,self.showEffectTime);
	if self.cardInfo ~= nil then
		self.cardInfo:dispose();
		self.cardInfo:clear();
		self.cardInfo = nil;
	end
	if self.gradeInfo ~= nil then
		self.gradeInfo:dispose();
		self.gradeInfo:clear();
		self.gradeInfo = nil;
	end
	DataCenter.equipCopyData.isOnCardClick = nil; -- 点击选择卡牌奖励
	if self.tag_typev == 1 then -- 单人
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sEquipCopy();
	else
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sTeam();
	end
	
	self:superCall("dispose");
end










-- 分数
Lua_EquipCopyScoreItem = class("Lua_EquipCopyScoreItem", Lua_DisplayObject);
function Lua_EquipCopyScoreItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_EquipCopyScoreItem:buildShowItem()
	self:superCall("buildShowItem");

	self.scoreArr = Array();
end

function Lua_EquipCopyScoreItem:setData(grade, width)
	width = width == nil and 55 or width;

	local arr = DataCenter.equipCopyUtil:getCopyScoreArr(grade);
	local len1 = self.scoreArr:getSize();
	local len2 = arr:getSize();
	local len = len1 > len2 and len1 or len2;
	local icon;
	for i = 1, len do
		icon = self.scoreArr[i];
		if len2 >= i then
			if icon == nil then
				icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
				self.scoreArr:add(icon);
			else
				icon:setEnable(true);
			end
			icon.siblingIndex = 0;
			icon:setAltas("equipcopy_atlas_2", arr[i]);
			icon:resetSize();
			icon:setLocation((i - 1) * width - len2 / 2 * width + width / 2, 0, 0);
		else
			icon:setEnable(false);
		end
	end
end

function Lua_EquipCopyScoreItem:setGray(val)
	for i = 1, self.scoreArr:getSize() do
		self.scoreArr[i]:setGray(val);
	end
end

function Lua_EquipCopyScoreItem:dispose()
	if self.scoreArr ~= nil then
		self.scoreArr:dispose();
		self.scoreArr = nil;
	end
	self:superCall("dispose");
end










-- 进度
Lua_EquipCopyGradeItem = class("Lua_EquipCopyGradeItem", Lua_DisplayObject);
function Lua_EquipCopyGradeItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyGradeItem_skin");
end

function Lua_EquipCopyGradeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.scoreItem = Lua_EquipCopyScoreItem.new(self.content);
	self.scoreItem:setLocation(0, 20, 0);
	self.scoreItem:setScale(0.25, 0.25);
end

function Lua_EquipCopyGradeItem:setData(data)
	self.scoreItem:setData(data.grade);
	self.down_des.text = data.num;
end

function Lua_EquipCopyGradeItem:dispose()
	if self.scoreItem ~= nil then
		self.scoreItem:dispose();
		self.scoreItem = nil;
	end
	self:superCall("dispose");
end










-- 卡牌
Lua_EquipCopyCardItem = class("Lua_EquipCopyCardItem", Lua_DisplayObject);
function Lua_EquipCopyCardItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyCardItem_skin");
end

function Lua_EquipCopyCardItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.tag_open = false;--是否翻盘
	self.isRewardNum = false; -- 是否有奖励次数
	self.itemName:setEnable(false);
	self.showObj:SetActive(false);

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setLocation(0, 60, 0);
	self.itemIcon:setScale(0.95, 0.95, 0.95);
	self.itemIcon:setEnable(false);

	self.palyerHead = Lua_AvatarItem.new(self.showObj);
	self.palyerHead:setLocation(-4, -73.5, 0);
	self.palyerHead:setScale(0.6, 0.6, 0.6);

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgBtnClick);
end

-- 奖励位置
function Lua_EquipCopyCardItem:setType(val)
	self.typev = val; -- 1单人 2多人
end

-- 奖励位置
function Lua_EquipCopyCardItem:setIndex(index)
	self.index = index;
end

-- 评分
function Lua_EquipCopyCardItem:setGrade(grade)
	self.grade = grade;
	self.showIcon:setAltas("equipcopy_atlas_2","xui_jmd_label_"..6-grade);
	self.showIcon:resetSize();
end

-- 剩余奖励次数
function Lua_EquipCopyCardItem:setRewardState(bool)
	local spName;
	if DataCenter.equipCopyData.isOnCardClick then
		spName = bool and "xui_jmd_window_004" or "xui_jmd_window_005";
	else
		spName = bool and "xui_jmd_window_0"..(11+self.grade) or "xui_jmd_window_007";
	end
	self.bg:setAltas("equipcopy_atlas_3", spName);

	self.rewardState = bool;
	self.showIcon:setGray(not bool);
	self.itemIcon:setGray(not bool);
end

-- 设置角色信息
function Lua_EquipCopyCardItem:setPlayerInfo(playerInfo)
	self.playerInfo = playerInfo;
end

-- 设置奖励信息
function Lua_EquipCopyCardItem:setItemInfo(rewardInfo)
	self.rewardInfo = rewardInfo;
end

function Lua_EquipCopyCardItem:onBgBtnClick()
	if self.rewardState == false then
		OperateAlert.showLangValue(420080);
		return;
	end

	if DataCenter.equipCopyData.isOnCardClick == true then -- 是否点击了卡牌 卡牌点击一次后不能在点击别的卡牌
		return;
	end

	if self.tag_open then
		OperateAlert.showLangValue(420095);
		return
	end
	print("点击翻牌 = =",self.index)
	DataCenter.equipCopyData.isOnCardClick = true;
	Lua_MsgUtil.callFunc("ON_CARD_ITEM", self.index);

	-- self:onStartComplete(); -- test翻牌
end

-- 开始翻牌
function Lua_EquipCopyCardItem:onStartComplete()
	if self.tag_open then
		return
	end

	self.tag_open = true;
	TweenUtil.getInstance():addTween(self.mainContent, 0.3, 0, 
	self.x, self.y, 0, 
	0, 0, 0, 
	0, 1, 1, 
	self, self.onAgainComplete, 0, false);
end

-- 翻盘兼换UI
function Lua_EquipCopyCardItem:onAgainComplete()
	self:showPanelInfo();
	TweenUtil.getInstance():addTween(self.mainContent, 1, 0, 
	self.x, self.y, 0, 
	0, 0, 0, 
	1, 1, 1, 
	self, self.overComplete, 0, false);
end

-- 展示翻牌后信息
function Lua_EquipCopyCardItem:showPanelInfo()
	self.showIcon:setEnable(false);
	self.itemName:setEnable(true);
	
	if self.playerInfo == nil then -- 玩家信息
		self.showObj:SetActive(false);
	else
		self.showObj:SetActive(true);
		self.playerName.text = self.playerInfo.name;
		self.palyerHead:setRoleDressUp(self.playerInfo.dress_info); -- 头像
	end

	-- print("self.rewardInfo", self.rewardInfo)
	if self.rewardInfo ~= nil then -- 道具信息
		self.tvo = Lua_ToolVo.createToolVo(self.rewardInfo[1].id, self.rewardInfo[1].amount)
		self.itemIcon:setData(self.tvo);
		self.itemIcon:setEnable(true);
		self.itemName:setEnable(true);
		self.itemName.text = self.tvo.name;
	end
	self.bg:setAltas("equipcopy_atlas_3", "xui_jmd_window_004");
end

function Lua_EquipCopyCardItem:overComplete()
	TweenUtil.getInstance():stop(self.mainContent);
	Lua_MsgUtil.callFunc("ON_HARVEST_ITEM_OVER", self.index);
end

function Lua_EquipCopyCardItem:dispose()
	self.tvo = nil;
	TweenUtil.getInstance():stop(self.mainContent);
	self:superCall("dispose");
end