-- 通用战斗失败窗口
checkRequire("Lua_FightResultBaseWindow");
Lua_FightFailResultWindow = class("Lua_FightFailResultWindow", Lua_FightResultBaseWindow)
function Lua_FightFailResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FightFailResultWindow";
	self.skinName = "FightFailResultWindow_skin";
    self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
    self.openSound = "fight_lose_01";

	self.bIsWin = false;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_FightFailResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.btnBack:addClickFuntion(self, self.onBackClick);
	self.btnSure:addClickFuntion(self, self.hide);
end

function Lua_FightFailResultWindow:hide()
	local config = Lua_FightTemplateConfigData.getConfigData(self.templateId)
	if config and config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then -- 主线冒险
		local iconId = DataCenter.mainMenuData.selectMainIconId;
		local vo = DataCenter.funcPathUtil:getFuncPathVo(1005)
		if iconId == Lua_MenuViewDefine.ICON_MAINLINE and not vo.isShowing then
			DataCenter.funcPathUtil:gotoFunction(1005, true, false)
		end
	end
	self:superCall("hide");
end

function Lua_FightFailResultWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;
	self:updateFuncIcons("showObject_2");
end

function Lua_FightFailResultWindow:onBackClick()
	local config = Lua_FightTemplateConfigData.getConfigData(self.templateId)
	if config and config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then -- 主线冒险
		DataCenter.funcPathUtil:gotoFunction(1005, true, false);
	elseif self.templateId == 1012 or self.templateId == 1038 then -- 边境远征
		DataCenter.funcPathUtil:gotoFunction(1016, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_LEAGUEBOSS then -- 公会BOSS
		DataCenter.funcPathUtil:gotoFunction(1062, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then -- 魔灵岛
		DataCenter.funcPathUtil:gotoFunction(1037, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_DIVINEDOMAINTRIAL then -- 神域试炼
		DataCenter.funcPathUtil:gotoFunction(1142, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVE then
		if Lua_WindowUtil.isWindowShowing("Lua_WildSecretWindow") then
			self:hide();
		else
			DataCenter.funcPathUtil:gotoFunction(1161, true, false, "Lua_WildStageWindow");
		end
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVP_1 or self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVP_2 then
		if Lua_WindowUtil.isWindowShowing("Lua_WildSecretWindow") then
			self:hide();
		else
			DataCenter.funcPathUtil:gotoFunction(1162, true, false, "Lua_WildLodeWindow");
		end
	else
		DataCenter.funcPathUtil:gotoFunction(1001, true, false);
	end
end