-- 结算基类
checkRequire("Lua_FightTemplateConfigData");
checkRequire("Lua_FightResultRewardItem");
Lua_FightResultBaseWindow = class("Lua_FightResultBaseWindow", Lua_Window)
function Lua_FightResultBaseWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.isFullPaving = true;
	self.isFullSizeWin = true;
	self.isFullSizeBg = true
	self.showWinBg = true;
	self.winBgPath = "";

	self.bIsWin = nil; -- 是否胜利 nil不显示
	self.bIsShowCountTime = false; -- 是否显示倒计时
	self.bIsShowHurtBtn = false; -- 是否显示伤害统计按钮
	self.bAutoNextFight = false; -- 是否自动下一关挑战
	self.autoNextLangId = 302010;
end

function Lua_FightResultBaseWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("FightResultWin_Timer_Stop", self, self.onCancelTimer);
	self:addLuaEvent("ITEM_DETAILS_CLOSE", self, self.onContinueTimer);
	self:addLuaEvent("FIGHT_OVERALL_HURT_CLOSE", self, self.onContinueTimer);

	if self.bIsWin == true then
		-- self.uiEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zdjs_sl_01", "ui_zdjs_sl_01", 0, 925)
		-- self.uiEff.anchorValue = 7;
		self.bearImg = UICreate.createImage(self.content, "/images/fight/xui_zd_widget_1.png", 32, 430, 0, 0);
		self.titleName = UICreate.createUIAtlasImage(self.content, "fight_atlas_3", "xui_zd_word_1", 39, 225, 0, 0);
	elseif self.bIsWin == false then
		-- self.uiEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_zdjs_sb_01", "ui_zdjs_sb_01", 0, 925)
		-- self.uiEff.anchorValue = 7;
		self.bearImg = UICreate.createImage(self.content, "/images/fight/xui_zd_widget_2.png", 32, 430, 0, 0);
		self.titleName = UICreate.createUIAtlasImage(self.content, "fight_atlas_3", "xui_zd_word_2", 39, 225, 0, 0);
	end

	if self.bIsShowHurtBtn == true then
		if self.hurtBtn == nil then
			self.hurtBtn = UICreate.createUIAtlasImage(self.content, "fight_atlas_2", "xui_zd_button_026_n", 277, 77, 0, 0);
			self.hurtBtn.anchorValue = 7;
		end
		self.hurtBtn:addClickFuntion(self, self.onBtnHurtClick);
	end
end

function Lua_FightResultBaseWindow:dispose()
	-- self:recordMainLineResult();
	self.bGuiding = nil;
	self.guideItemPathStr = nil;
	self:onRemove()
	if self.uiEff then
		self.uiEff:dispose();
		self.uiEff = nil;
	end
	self:removeFuncIcons();
	DataCenter.funcPathUtil:checkFightRecordFuncPath(self.recordId);
	if self.templateId == 1012 or self.templateId == 1038 then -- 边境远征
		DataCenter.expeditionData:checkTips();
	end
	
	self:superCall("dispose");
	DataCenter.fightData:showNextResult();
end

function Lua_FightResultBaseWindow:hide()
	self:onRemove()
	local winNamme = DataCenter.fightData:showNextResult();
	if winNamme ~= self.windowName then
		self:superCall("hide");
	end
end

-- 记录该关卡是否已弹出结算界面，引导用
function Lua_FightResultBaseWindow:recordMainLineResult()
	if self.bIsWin and self.showData ~= nil then
		local config = Lua_FightTemplateConfigData.getConfigData(self.showData.template_id)
		if config then 
			if config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then -- 主线
				DataCenter.fightData:recordFightResult(Lua_FightDefine.FIGHT_TYPE_MAINLINE, self.showData.stage_id);
				Lua_MsgUtil.callFunc("UPDATE_MAINLINE_INFO");
			elseif config.sys_type == Lua_FightDefine.FIGHT_TYPE_STORYLEVEL then -- 剧情
				DataCenter.fightData:recordFightResult(Lua_FightDefine.FIGHT_TYPE_STORYLEVEL, self.showData.stage_id);
				Lua_MsgUtil.callFunc("UPDATE_FIGHTTYPE_RESULT_WIN");
			end
		end
	end
end

function Lua_FightResultBaseWindow:onRemove()
	self:stopTimer();
	DataCenter.popupWinManager:removeDataByName(self.windowName);
	DataCenter.fightData:removeFightResult(self.recordId);
	DataCenter.fightData:removeFight(self.recordId);
	if self.templateId == 1012 or self.templateId == 1038 then -- 边境远征
		Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sHaveHeroList();
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_TIME_SPACE_RACE then -- 时空争霸
		Lua_ProxyManager.getProxy("Lua_TimeSpaceRaceProxy"):sResultReward();
	end
end

function Lua_FightResultBaseWindow:showWin(param)
	self.bGuiding = nil;
	self.guideItemPathStr = nil;
	self:superCall("showWin", param);
	self.recordId = tonumber(param.record_id);
	self.templateId = tonumber(param.template_id);
	DataCenter.fightData.curShowResultRecordId = self.recordId;
	self:initCountTime();

    if self.templateId == Lua_FightDefine.TEMPLATE_ID_ARENA then -- 斗技场
        DataCenter.chatData:playNextBroadcast(1053);
        DataCenter.chatData:playNextBroadcast(1054);
        DataCenter.chatData:playNextBroadcast(1055);
    elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_FORMTEAMCOMPETITAION then -- 斗技场
        DataCenter.chatData:playNextBroadcast(1068);
        DataCenter.chatData:playNextBroadcast(1069);
        DataCenter.chatData:playNextBroadcast(1070);
        DataCenter.chatData:playNextBroadcast(1071);
        DataCenter.chatData:playNextBroadcast(1072);
        DataCenter.chatData:playNextBroadcast(1073);
        DataCenter.chatData:playNextBroadcast(1074);
        DataCenter.chatData:playNextBroadcast(1075);
    end
end

function Lua_FightResultBaseWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	if bActive == true then
		self.bPauseTimer = false;
	else
		self.bPauseTimer = true;
	end
end

-- 初始化倒计时
function Lua_FightResultBaseWindow:initCountTime()
	self:stopTimer();
	if self.bIsShowCountTime then
		self.countTime = DataCenter.fightUtil.resultWinCloseTime;
		if self.closeText == nil then
			self.closeText = UICreate.createLabel(self.content, nil, 0, -597, 100, 31, 26);
			self.closeText.pivotValue = 4;
			self.closeText.alignmentValue = 4;
			self.closeText.horizontalOverflowValue = 1;
			self.closeText.verticalOverflowValue = 1;
			self.closeText.colorStr = Lua_ColorDefine.transColorStr("8B8A8A");
		end
		if self.bAutoNextFight then
			self.closeText.text = LanUtil.formateStr(self.autoNextLangId, tostring(self.countTime));
		else
			self.closeText.text = LanUtil.formateStr(302003, tostring(self.countTime));
		end
		self:startTimer();
	end
end

function Lua_FightResultBaseWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_FightResultBaseWindow", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_FightResultBaseWindow:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_FightResultBaseWindow:onTimer()
	if self.bPauseTimer == true then
		return;
	end

	self.countTime = self.countTime - 1;
	if self.countTime <= 0 then
		self:stopTimer();
		if self.bAutoNextFight then
			self:onAutoFight();
		else
			self:hide();
		end
		return;
	end

	if self.bAutoNextFight then
		self.closeText.text = LanUtil.formateStr(self.autoNextLangId, tostring(self.countTime));
	else
		self.closeText.text = LanUtil.formateStr(302003, tostring(self.countTime));
	end
end

function Lua_FightResultBaseWindow:updateFuncIcons(goName)
	self.guideItemPathStr = goName;
	local configData = Lua_FightTemplateConfigData.getConfigData(self.templateId);
	local list = configData.failOpenIcons;
	if list == nil or #list <= 0 then
		self:removeFuncIcons();
	else
		if self.iconsList == nil then
			self.iconsList = Array();
		end
		local len = self.iconsList:getSize();
		local num = #list - len;

		local go = self[goName] or self.content
		while (num > 0) do
			item = Lua_IconSkipItem.new(go);
			self.iconsList:add(item);
			num = num - 1;
		end

		while (num < 0) do
			item = self.iconsList:remove(1);
			item:dispose();
			num = num + 1;
		end

		len = self.iconsList:getSize();
		local space = 140;
		local w;
		local posX;
		local posY;
		for i = 1, len do
			item = self.iconsList[i];
			item:setClick(self, self.onIconSkip);
			item:setData(list[i]);

			w = -(space * len) / 2 + space / 2;
			posX = ((i - 1) % len) * space + w;
			posY = -260 + Mathf.Floor((i - 1) / len) * -space;
			item:setLocation(posX, posY, 0);
		end
	end

	if DataCenter.funcOpenData:isOpened(10002) then
		self:activeGuideId(); -- 引导用
	end
end

function Lua_FightResultBaseWindow:removeFuncIcons()
	if self.iconsList ~= nil then
		self.iconsList:dispose();
		self.iconsList:clear();
		self.iconsList = nil;
	end
end

function Lua_FightResultBaseWindow:onIconSkip(funcPathId)
	DataCenter.guideData.ignoreGuideLimit = true;
	DataCenter.funcPathUtil:gotoFunction(funcPathId, true);
end

function Lua_FightResultBaseWindow:onBtnHurtClick(go)
	if self.showData == nil then
		return;
	end
	
	local info = self.showData.hurt_collect;
	local list = info.hurt_collect_list;
	local len = 0;
	for i = 1, #list do
		if list[i].attacker_hurt_collect == nil or #list[i].attacker_hurt_collect <= 0 
			or list[i].defender_hurt_collect == nil or #list[i].defender_hurt_collect <= 0 then
			len = len + 1;
		end
	end
	if len >= #list then
		OperateAlert.showLangValue(302013);
		return;
	end
	self:onCancelTimer();
	Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, info);
end

function Lua_FightResultBaseWindow:onBtnStrongerClick(go)
	if self.showData == nil then
		return;
	end
	self:onCancelTimer();
	DataCenter.funcPathUtil:gotoFunction(1054)
end

-- 取消倒计时
function Lua_FightResultBaseWindow:onCancelTimer()
	-- self:stopTimer();
	-- if self.closeText ~= nil then
	-- 	self.closeText.text = nil;
	-- end
	self.bPauseTimer = true
end

function Lua_FightResultBaseWindow:onContinueTimer()
	self.bPauseTimer = false
end

function Lua_FightResultBaseWindow:activeGuideId()
	local guideData = DataCenter.guideData;
	if guideData.bOpenGuide then
		local hasIcon = self:hasIconById(1019);
		local failGuideIdList = getConfig("guide_const","fail_GuideId","arr_value");
		if hasIcon and not self.bIsWin and failGuideIdList ~= nil then
			for i = 1, #failGuideIdList do
				local failGuideId = failGuideIdList[i];
				if not guideData:checkGuideComplete(failGuideId, nil) and DataCenter.guideUtil:getGuideCfg(failGuideId) then
					self:onCancelTimer();
					if self.closeText ~= nil then
						self.closeText.text = nil;
					end
					DataCenter.guideCommonData:setInheritWindowName(self.windowName);
					DataCenter.guideData:play(failGuideId);
					break;
				end
			end
		end
	end
end

-- 检测引导数据
function Lua_FightResultBaseWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_FightResultBaseWindow:updateGuide(guideId, info)
    if info == nil then
        return;
    end

    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end

	if operateVal == 1 then -- 失败英雄培养
		local iconId = info.iconId;
		if iconId == nil or self.bIsWin then
			return; 
		end

		local hasIcon, iconItem = self:hasIconById(iconId);
		if hasIcon then
			local pathStr = self.guideItemPathStr;
			pathStr = pathStr and "content/"..pathStr.."/" or "content/";
			self.bGuiding = true;
            DataCenter.guideCommonData.guideSceneId = nil; -- 场景
			DataCenter.guideCommonData.guideClickObjPath = pathStr..iconItem.content.name.."/icon";
			-- DataCenter.guideCommonData:setInheritWindowName(nil);
			Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
		end
	end
end

function Lua_FightResultBaseWindow:hasIconById(iconId)
	if self.iconsList ~= nil then
		local iconItem;
		for i = 1, self.iconsList:getSize() do
			iconItem = self.iconsList[i];
			if iconItem ~= nil and iconItem.data ~= nil and iconItem.data.id == iconId then
				return true, iconItem;
			end
		end
	end

	return false;
end

function Lua_FightResultBaseWindow:onAutoFight()
	
end