-- 通用战斗胜利窗口
checkRequire("Lua_FightResultBaseWindow");
Lua_FightWinResultWindow = class("Lua_FightWinResultWindow", Lua_FightResultBaseWindow)
function Lua_FightWinResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FightWinResultWindow";
	self.skinName = "FightWinResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";

	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_FightWinResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.btnBack:addClickFuntion(self, self.onBackClick);
	self.btnSure:addClickFuntion(self, self.onSureClick);
end

function Lua_FightWinResultWindow:dispose()
	self:recordMainLineResult();
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_FightWinResultWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;
	self:updateRewards(param.item_list);
end

function Lua_FightWinResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self.rewardTitle:setEnable(false);
		self.rewardBg:setEnable(false);
		self:clearRewardList();
		return;
	end

	self.rewardTitle:setEnable(true);
	self.rewardBg:setEnable(true);
	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardBg:SetDimensions(720, 266);
			self.rewardList = Lua_DragList.new(self.showObject_2, 560, 240, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 166, 4);
			self.rewardList:setLocation(0, -211, 0);
		else
			self.rewardBg:SetDimensions(720, 176);
			self.rewardList = Lua_DragList.new(self.showObject_2, len * 124 + (len - 1) * 20+4, 166, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 166, 4);
			self.rewardList:setLocation(0, -207, 0);
		end
		self.rewardList:setCellSpacing(20, 0);
		self.rewardList:setRectPivot(1)
		self.rewardList.tweenId = 2007;
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_FightWinResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_FightWinResultWindow:onBackClick(go)
	if self.templateId == 1012 or self.templateId == 1038 then -- 边境远征
		DataCenter.funcPathUtil:gotoFunction(1016, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_STORY then -- 剧情关卡
		DataCenter.funcPathUtil:gotoFunction(1031, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_LEAGUEBOSS then -- 公会BOSS
		if Lua_WindowUtil.isWindowShowing("Lua_AllianceBossWindow") then
			self:hide();
		else
			DataCenter.funcPathUtil:gotoFunction(1062, true, false);
		end
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_DIVINEDOMAINTRIAL then -- 神域试炼
		DataCenter.funcPathUtil:gotoFunction(1142, true, false);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVE then
		if Lua_WindowUtil.isWindowShowing("Lua_WildSecretWindow") then
			self:hide();
		else
			DataCenter.funcPathUtil:gotoFunction(1161, true, false, "Lua_WildStageWindow");
		end
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVP_1 or self.templateId == Lua_FightDefine.TEMPLATE_ID_WILD_PVP_2 then
		if Lua_WindowUtil.isWindowShowing("Lua_WildSecretWindow") then
			self:hide();
		else
			DataCenter.funcPathUtil:gotoFunction(1162, true, false, "Lua_WildLodeWindow");
		end
	else
		DataCenter.funcPathUtil:gotoFunction(1001, true, false);
	end
end

function Lua_FightWinResultWindow:onSureClick(go)
	self:hide();
end