-- 组队赛
checkRequire("Lua_FightResultBaseWindow");
Lua_FormTeamCompetitionFightWinWindow = class("Lua_FormTeamCompetitionFightWinWindow", Lua_FightResultBaseWindow);
function Lua_FormTeamCompetitionFightWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FormTeamCompetitionFightWinWindow";
	self.skinName = "FormTeamCompetitionFightWinWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D)
	self.openSound = "fight_win_01"

	self.bIsWin = true;
	self.bIsShowCountTime = true;
end

function Lua_FormTeamCompetitionFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.processBar:setMaxValue(1);
	self.processBar:setValue(0);
	self.sureBtn:addClickFuntion(self, self.hide);

	Lua_WindowUtil.openWin("Lua_FormTeamCompetitionTeamAdjustWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_FormTeamCompetitionFightWinWindow:dispose()
	self:stopProcessTimer();
	self:superCall("dispose");
end

function Lua_FormTeamCompetitionFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;

	local info = param.arena_self_info;
	local curStageId = param.role_info and param.role_info.level or 0;
	local cfg = getConfig("team_arena_grade", curStageId);
	if cfg == nil then
		return;
	end
	self.curTeamStageSp:setUrl(cfg.path);
	self.curTeamStageTxt.text = cfg.name;

	local nextId = info and info.level or 0;
	local checkNextId;
	if nextId == curStageId then
		checkNextId = cfg.next_id;
	else
		checkNextId = nextId;
	end
	checkNextId = checkNextId or 0;
	cfg = getConfig("team_arena_grade", checkNextId);
	if cfg == nil then
		return;
	end
	self.nextTeamStageSp:setUrl(cfg.path);
	self.nextTeamStageTxt.text = cfg.name;
	local nextScoreValue = cfg.score;

	local addValue = info and info.score_change or 0;
	self.lastScoreValue = info and info.score or 0;
	self.curScoreValue = self.lastScoreValue + addValue;
	self.curValue = self.lastScoreValue;
	self.perValue = addValue / (1 / 0.02);
	self.processBar:setMaxValue(nextScoreValue);
	self.processBar:setValue(self.lastScoreValue);

	self:onProcessTimer();
	self:startProcessTimer();

	self.processTxt.text = LanUtil.formateStr(772123, self.curScoreValue, nextScoreValue);
	self.scoreNumTxt.text = LanUtil.formateStr(772124, self.lastScoreValue, addValue);

	if curStageId ~= nextId and self.curScoreValue >= nextScoreValue then
		self:openUpStageWin(true, curStageId, nextId);
	end
end

function Lua_FormTeamCompetitionFightWinWindow:startProcessTimer()
	if self.bProcessTimer ~= true then
		self.bProcessTimer = true
		self:addTimer("Lua_FormTeamCompetitionFightWinWindow", 0.02, self, self.onProcessTimer)
	end
end

function Lua_FormTeamCompetitionFightWinWindow:stopProcessTimer()
	if self.bProcessTimer == true then
		self.bProcessTimer = false
		self:removeTimer(self, self.onProcessTimer)
	end
end

function Lua_FormTeamCompetitionFightWinWindow:onProcessTimer()
	self.curValue = self.curValue + self.perValue;
	self.processBar:setValue(self.curValue);
	if self.curValue >= self.curScoreValue then
		self:stopProcessTimer();
	end
end

function Lua_FormTeamCompetitionFightWinWindow:openUpStageWin(bShow, stageId, nextId)
	if bShow then
		Lua_WindowUtil.openWin("Lua_FormTeamCompetitionUpStageWindow", Lua_WinParam.ACTION_OPEN, {stageId = stageId, nextId = nextId});
	end
end

