-- 神海之巅
checkRequire("Lua_FightResultBaseWindow");
Lua_GodSeaPeakFightResultWindow = class("Lua_GodSeaPeakFightResultWindow", Lua_FightResultBaseWindow);
function Lua_GodSeaPeakFightResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GodSeaPeakFightResultWindow";
	self.skinName = "GodSeaPeakFightResultWindow_skin";
	self.showBlackMask = true;
	self.showWinBg = false;

	self.bIsWin = nil;
	self.bIsShowHurtBtn = true;
end

function Lua_GodSeaPeakFightResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.battleList = Array();
	self.defendList = Array();
	self.attackList = Array();

	self.defengAavatar = Lua_AvatarItem.new(self.showObject);
	self.defengAavatar:setScale(0.5, 0.5, 1);
	self.defengAavatar:setLocation(320, 66, 0);

	self.attackAavatar = Lua_AvatarItem.new(self.showObject);
	self.attackAavatar:setScale(0.5, 0.5, 1);
	self.attackAavatar:setLocation(-324, 32, 0);
	self.attackAavatar:setRoleDressUp(DataCenter.roleData.dress_info);

	self.attackNameText.text = DataCenter.roleData.name;
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
	self.btnSubmit:addClickFuntion(self, self.hide);

	Lua_WindowUtil.openWin("Lua_GodSeaPeakFightWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_GodSeaPeakFightResultWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.showBattleTween);
	if self.defengAavatar then
		self.defengAavatar:dispose();
		self.defengAavatar = nil;
	end
	if self.attackAavatar then
		self.attackAavatar:dispose();
		self.attackAavatar = nil;
	end
	if self.battleList then
		self.battleList:dispose();
		self.battleList:clear();
		self.battleList = nil;
	end
	if self.defendList then
		self.defendList:dispose();
		self.defendList:clear();
		self.defendList = nil;
	end
	if self.attackList then
		self.attackList:dispose();
		self.attackList:clear();
		self.attackList = nil;
	end
	self:clearRewardList();
	if Lua_WindowUtil.isWindowShowing("Lua_GodSeaPeakWindow") then
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sWinInfo(0);
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sCheckScore();
	end
	if self.showData and Lua_WindowUtil.isWindowShowing("Lua_GodSeaPeakMatchWindow") then
		Lua_ProxyManager.getProxy("Lua_GodSeaPeakProxy"):sMatchInfo(self.showData.result);
	end
	self:superCall("dispose");
end

function Lua_GodSeaPeakFightResultWindow:showWin(param)
	self:superCall("showWin", param);

	self.hurtList = param.hurt_collect.hurt_collect_list;
	table.sort(self.hurtList, function(a, b) return a.rotation < b.rotation end);

	for i = 1, self.battleList:getSize() do
		self.battleList[i]:setEnable(false);
	end
	if DataCenter.godSeaPeakData.isSkip then
		self.showObject:SetActive(false);
		self.battleTweenIdx = 1;
		self:showBattleTween();
	else
		self.showObject:SetActive(true);
		self.bIsShowCountTime = true;
		self:initCountTime();
	end

	if param.result == 1 then
		self.resultIcon:setAltas("fight_atlas_3", "xui_zd_word_1");
	else
		self.resultIcon:setAltas("fight_atlas_3", "xui_zd_word_2");
	end

	self.defengAavatar:setRoleDressUp(param.god_sea_fighter_info.dress_info);
	self.defendNameText.text = param.god_sea_fighter_info.name;

	local score_change = param.god_sea_fighter_info.score_change;
	local score = param.god_sea_fighter_info.score;
	if score_change > 0 then
		score_change = Lua_ColorDefine.getColorStr("4ADC3F", "+"..score_change);
	else
		score_change = Lua_ColorDefine.getColorStr("FF5555", score_change);
	end
	self.defendIntegralText.text = LanUtil.formateStr(790028, tostring(score), tostring(score_change));

	score_change = param.god_sea_self_info.score_change;
	score = param.god_sea_self_info.score;
	if score_change > 0 then
		score_change = Lua_ColorDefine.getColorStr("4ADC3F", "+"..score_change);
	else
		score_change = Lua_ColorDefine.getColorStr("FF5555", score_change);
	end
	self.attackIntegralText.text = LanUtil.formateStr(790028, tostring(score), tostring(score_change));

	local item;
	for i = 1, 3 do
		item = self.defendList[i];
		if item == nil then
			item = Lua_GodSeaPeakFightResultItem.new(self.showObject);
			self.defendList:add(item);
		end
		if i == 1 then
			item:setLocation(-241, 271, 0);
		elseif i == 2 then
			item:setLocation(0, 244, 0);
		else
			item:setLocation(241, 219, 0);
		end
		if i <= #self.hurtList then
			item:setData(i, self.hurtList[i].defender_hurt_collect, self.hurtList[i].aod_win);
		else
			item:setData(i, nil, 0);
		end
	end

	local attackNum = 0;
	local defendNum = 0;
	for i = 1, 3 do
		item = self.attackList[i];
		self["result_icon_"..i]:setEnable(false);
		if item == nil then
			item = Lua_GodSeaPeakFightResultItem.new(self.showObject);
			self.attackList:add(item);
		end
		if i == 1 then
			item:setLocation(-241, -111, 0);
		elseif i == 2 then
			item:setLocation(0, -138, 0);
		else
			item:setLocation(241, -162, 0);
		end
		if i <= #self.hurtList then
			if self.hurtList[i].aod_win == 1 then
				attackNum = attackNum + 1;
				self["result_icon_"..i]:setEnable(true);
				self["result_icon_"..i]:setAltas("common_altas_4", "xui_jys_label_1");
			elseif self.hurtList[i].aod_win == 2 then
				defendNum = defendNum + 1;
				self["result_icon_"..i]:setEnable(true);
				self["result_icon_"..i]:setAltas("common_altas_4", "xui_jys_label_2");
			end
			item:setData(i, self.hurtList[i].attacker_hurt_collect, self.hurtList[i].aod_win);
		else
			item:setData(i, nil, 0);
		end
	end
	self.scoreText.text = LanUtil.formateStr(10050, tostring(attackNum), tostring(defendNum));

	self:updateRewards(param.item_list);
end

function Lua_GodSeaPeakFightResultWindow:showBattleTween()
	Lua_CommonUtil.removeTimer(self, self.showBattleTween);

	local idx = self.battleTweenIdx;
	if idx > 3 then
		for i = 1, self.battleList:getSize() do
			self.battleList[i]:setEnable(false);
		end
		self.showObject:SetActive(true);
		self.bIsShowCountTime = true;
		self:initCountTime();
	else
		local item = self.battleList[idx];
		if item == nil then
			item = Lua_GodSeaPeakBattleItem.new(self.content);
			self.battleList:add(item);
		end
		if idx == 1 then
			item:setLocation(-241, 96, 0);
		elseif idx == 2 then
			item:setLocation(0, 68, 0);
		else
			item:setLocation(241, 41, 0);
		end
		if self.hurtList and self.hurtList[idx] then
			item:setData(self.hurtList[idx].aod_win);
		else
			item:setData(0);
		end

		self.battleTweenIdx = idx + 1;
		Lua_CommonUtil.delayCall(1, self, self.showBattleTween);
	end
end

function Lua_GodSeaPeakFightResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.showObject, 556, 240, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 160, 4);
		else
			self.rewardList = Lua_DragList.new(self.showObject, len * 124 + (len - 1) * 20, 160, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 160, 4);
		end
		self.rewardList:setCellSpacing(20, 0);
		self.rewardList:setRectPivot(1)
		self.rewardList:setLocation(0, -299, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_GodSeaPeakFightResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_GodSeaPeakFightResultWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1186, true, false);
end










Lua_GodSeaPeakFightResultItem = class("Lua_GodSeaPeakFightResultItem", Lua_DisplayObject)
function Lua_GodSeaPeakFightResultItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GodSeaPeakFightResultItem:buildShowItem()
	self:superCall("buildShowItem");
	self.heroList = Array();
	self.dataList = Array();
end

function Lua_GodSeaPeakFightResultItem:dispose()
	if self.heroList then
		self.heroList:dispose();
		self.heroList:clear();
		self.heroList = nil;
	end
	if self.dataList then
		self.dataList:clear();
		self.dataList = nil;
	end
	self:superCall("dispose");
end

function Lua_GodSeaPeakFightResultItem:setData(idx, list, winResult)
	local arr = Array();
	if list then
		for i = 1, #list do
			if list[i].type == 0 or list[i].type == 1 then
				arr:add(list[i]);
			end
		end
	end

	local num = idx * 2;
	local len = self.heroList:getSize();
	local maxLen = num > len and num or len;
	local item, vo, heroId;
	for i = 1, maxLen do
		item = self.heroList[i];
		if i > num then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ItemIcon.new(self.content);
				item:setScale(0.5, 0.5, 1);
				self.heroList:add(item);
			else
				item:setEnable(true);
			end
			if num == 2 then
				item:setLocation(-35 + (i - 1) * 65, 0, 0);
			elseif num == 4 then
				if i == 1 then
					item:setLocation(0, 34, 0);
				else
					item:setLocation(-130 + (i - 1) * 65, -32, 0);
				end
			else
				if i < 4 then
					item:setLocation(-65 + (i - 1) * 65, 34, 0);
				else
					item:setLocation(-260 + (i - 1) * 65, -32, 0);
				end
			end

			if arr[i] == nil then
				item:setData(nil);
			else
				heroId = tonumber(arr[i].sort_id);
				if arr[i].type == 1 then
					heroId = Lua_MonsterConfigData.getMonsterConfig(heroId).heroId;
				end
				vo = self.dataList[i];
				if vo == nil then
					vo = Lua_HeroVo.new(heroId);
					self.dataList:add(vo);
				else
					vo:setData(heroId);
				end
				vo.level = arr[i].level;
				vo.quality = arr[i].quality;
				vo.quality_star = arr[i].quality_star;
				vo.clothesId = arr[i].clothes_id;
				item:setData(vo);
				item:setGray(arr[i].health <= 0 and winResult > 0);
			end
		end
	end
end










Lua_GodSeaPeakBattleItem = class("Lua_GodSeaPeakBattleItem", Lua_DisplayObject)
function Lua_GodSeaPeakBattleItem:ctor(p)
	self:superCall("ctor", p, "GodSeaPeakBattleItem_skin");
end

function Lua_GodSeaPeakBattleItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GodSeaPeakBattleItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onTweenComplete);
	TweenUtil.getInstance():stop(self.enemyImg.mainContent);
	TweenUtil.getInstance():stop(self.selfImg.mainContent);
	if self.uiEff then
		self.uiEff:dispose();
		self.uiEff = nil;
	end
	self:superCall("dispose");
end

function Lua_GodSeaPeakBattleItem:setData(result)
	self.enemyResult:setEnable(false);
	self.selfResult:setEnable(false);
	if result == 1 then
		self.enemyResult:setAltas("common_altas_4", "xui_jys_label_2");
		self.selfResult:setAltas("common_altas_4", "xui_jys_label_1");
	elseif result == 2 then
		self.enemyResult:setAltas("common_altas_4", "xui_jys_label_1");
		self.selfResult:setAltas("common_altas_4", "xui_jys_label_2");
	end
	self:playTween(result);
end

function Lua_GodSeaPeakBattleItem:playTween(result)
	Lua_CommonUtil.removeTimer(self, self.onTweenComplete);
	TweenUtil.getInstance():stop(self.enemyImg.mainContent);
	TweenUtil.getInstance():stop(self.selfImg.mainContent);
	if result == 0 then
		self.enemyImg:setLocation(-13.5, 231, 0);
		self.selfImg:setLocation(-13.5, -218, 0);
		if self.uiEff then
			self.uiEff:setEnable(false);
		end
	else
		TweenUtil.getInstance():addTweenTargetPos(self.enemyImg.mainContent, 0.25, 0, -13.5, 0, 0);
		TweenUtil.getInstance():addTweenTargetPos(self.enemyImg.mainContent, 0.25, 0.25, -13.5, 231, 0);
		
		TweenUtil.getInstance():addTweenTargetPos(self.selfImg.mainContent, 0.25, 0, -13.5, 0, 0);
		TweenUtil.getInstance():addTweenTargetPos(self.selfImg.mainContent, 0.25, 0.25, -13.5, -218, 0);

		Lua_CommonUtil.delayCall(0.15, self, self.onTweenComplete, 1);
	end
end

function Lua_GodSeaPeakBattleItem:onTweenComplete(value)
	if value == 1 then
		if self.uiEff == nil then
			self.uiEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_shzd_pz", "ui_shzd_pz", 0, 0);
		else
			self.uiEff:setEnable(false);
			self.uiEff:setEnable(true);
		end
		Lua_CommonUtil.removeTimer(self, self.onTweenComplete);
		Lua_CommonUtil.delayCall(0.35, self, self.onTweenComplete, 2);
	elseif value == 2 then
		self.enemyResult:setEnable(true);
		self.selfResult:setEnable(true);
	end
end