-- 英雄试炼胜利面板
checkRequire("Lua_FightResultBaseWindow");
Lua_HeroTrialFightWinResultWindow = class("Lua_HeroTrialFightWinResultWindow", Lua_FightResultBaseWindow);
function Lua_HeroTrialFightWinResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroTrialFightWinResultWindow";
	self.skinName = "HeroTrialFightWinWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";
	
	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_HeroTrialFightWinResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.backBtn:setStyle(7);
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_HeroTrialFightWinResultWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateShowInfo();
	self:updateRewards(param.item_list);
end

function Lua_HeroTrialFightWinResultWindow:updateShowInfo()
	self.scoreTxt.text = LanUtil.formateStr(750016, self.showData.arena_self_info.score);
	self.newRecordSp:setEnable(self.showData.arena_self_info.score_change > 0); -- is_new_hurt == 1);
end

function Lua_HeroTrialFightWinResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 540, 152, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 112, 152, 4);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 152, Lua_AxisDefine.Horizontal);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 112, 152, 1);
		end
		self.rewardList:setCellSpacing(23, 0);
		self.rewardList:setLocation(0, -358, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_HeroTrialFightWinResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_HeroTrialFightWinResultWindow:onBackBtnClick(go)
	local vo = DataCenter.backstageActData:getActVoByIdx(self.showData.stage_id);
	if vo.residueTime > 0 then
		Lua_WindowUtil.openWin(vo.main_win, Lua_WinParam.ACTION_OPEN, vo);
	else
		OperateAlert.showLangValue(750000);
	end
	print("活动索引id", self.showData.stage_id, vo.main_win);
	self:superCall("onBackBtnClick", go);
end

function Lua_HeroTrialFightWinResultWindow:dispose()
	self:clearRewardList();
	Lua_ProxyManager.getProxy("Lua_RankProxy"):sGetRankInfo(Lua_RankData.MONSTER_TYPE, 0); -- 排行榜信息
	
	self:superCall("dispose");
end