checkRequire("Lua_FightResultBaseWindow")
Lua_InfinityHallFightFailWindow = class("Lua_InfinityHallFightFailWindow", Lua_FightResultBaseWindow)
function Lua_InfinityHallFightFailWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_InfinityHallFightFailWindow"
	self.skinName = "InfinityHallFightFailWindow_skin"
	self.winBgPath = "/images/fight/xui_zd_bg_2.jpg"
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG)
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_lose_01"

	self.bIsWin = false
	self.bIsShowCountTime = true
	self.bIsShowHurtBtn = true
end

function Lua_InfinityHallFightFailWindow:buildShowItem()
	self:superCall("buildShowItem")

	self.rateBar.typeValue = 3
	self.rateBar.fillMethodValue = 0
	self.rateBar.fillOrigin = 0
	self.btnLeft:addClickFuntion(self, self.onBtnBackClick);
	self.btnRight:addClickFuntion(self, self.hide);
end

function Lua_InfinityHallFightFailWindow:dispose()
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose")
end

function Lua_InfinityHallFightFailWindow:showWin(param)
	self:superCall("showWin", param);
	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;

	local maxRound = DataCenter.infinityHallUtil:getConstConfig("max_round", 1, 0);
	self.rateBar:setMaxValue(maxRound);
	self.rateBar:setValue(param.pass_round);
	self.rateBar:setText(LanUtil.formateStr(10044, tostring(param.pass_round), tostring(maxRound)));

	local layerType = 1;
	if param.template_id == 1006 then
		layerType = 2;
	end
	local id;
	local config;
	for i = 1, maxRound do
		id = layerType * 10000000 + param.stage_id * 1000 + i;
		config = DataCenter.infinityHallUtil:getLayerConfig(id);
		if config and config.round > param.pass_round and config.reward then
			break;
		end
	end
	if config == nil then
		id = layerType * 10000000 + param.stage_id * 1000 + maxRound;
		config = DataCenter.infinityHallUtil:getLayerConfig(id);
	end
	self.promptText.text = LanUtil.formateStr(304039, tostring(config.round - param.pass_round));

	if self.itemIcon == nil then
		self.itemIcon = Lua_ItemIcon.new(self.content);
		self.itemIcon:setLocation(-170, -274, 0);
		self.itemIcon:setClick(self, self.onRewardClick);
		local tvo = Lua_ToolVo.createToolVo(config.reward[1][1], config.reward[1][2]);
		self.itemIcon:setData(tvo);
	end
end

function Lua_InfinityHallFightFailWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1014, true, false)
end

function Lua_InfinityHallFightFailWindow:onRewardClick(data)
	if data then
		DataCenter.packUtil:showItemInfo(data);
	end
	self:onCancelTimer();
end