checkRequire("Lua_FightResultBaseWindow")
Lua_InfinityHallFightWinWindow = class("Lua_InfinityHallFightWinWindow", Lua_FightResultBaseWindow)
function Lua_InfinityHallFightWinWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_InfinityHallFightWinWindow"
	self.skinName = "InfinityHallFightWinWindow_skin"
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg"
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG)
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01"

	self.bIsWin = true
	self.bIsShowCountTime = true
	self.bIsShowHurtBtn = true
end

function Lua_InfinityHallFightWinWindow:buildShowItem()
	self:superCall("buildShowItem")

	self.rateBar.typeValue = 3
	self.rateBar.fillMethodValue = 0
	self.rateBar.fillOrigin = 0
	self.btnLeft:addClickFuntion(self, self.onBtnBackClick);
	self.btnRight:addClickFuntion(self, self.hide);
end

function Lua_InfinityHallFightWinWindow:dispose()
	self:superCall("dispose")
end

function Lua_InfinityHallFightWinWindow:showWin(param)
	self:superCall("showWin", param);
	local templateConfig = Lua_FightTemplateConfigData.getConfigData(param.template_id);
	self.nameText.text = templateConfig.title;

	local maxRound = DataCenter.infinityHallUtil:getConstConfig("max_round", 1, 0);
	self.rateBar:setMaxValue(maxRound);
	self.rateBar:setValue(param.pass_round);
	self.rateBar:setText(LanUtil.formateStr(10044, tostring(param.pass_round), tostring(maxRound)));
end

function Lua_InfinityHallFightWinWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1014, true, false)
end