-- 昆墟圣地战斗失败界面
checkRequire("Lua_KunXuHolyLandHeroItem");
checkRequire("Lua_FightResultBaseWindow");
Lua_KunXuHolyLandFightFailWindow = class("Lua_KunXuHolyLandFightFailWindow", Lua_FightResultBaseWindow);
function Lua_KunXuHolyLandFightFailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_KunXuHolyLandFightFailWindow";
    self.winBgPath = "/images/fight/xui_zd_bg_2.jpg";
    self.skinName = "KunXuHolyLandFightFailWindow_skin";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sb_01", Lua_LoadFileType.UNITY3D);
    self.openSound = "fight_lose_01";
    
	self.bIsWin = false;
	self.bIsShowCountTime = false;
	self.bIsShowHurtBtn = true;
end

function Lua_KunXuHolyLandFightFailWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.leftHeroList = Lua_DragList.new(self.content, 567, 128, Lua_AxisDefine.Horizontal);
	self.leftHeroList:setRectAnchor(7);
	self.leftHeroList:setLocation(0, 493, 0);
   	self.leftHeroList:setListCell(Lua_KunXuHolyLandHeroItem, 108, 128, 1);

   	self.rightHeroList = Lua_DragList.new(self.content, 567, 128, Lua_AxisDefine.Horizontal);
   	self.rightHeroList:setRectAnchor(7);
	self.rightHeroList:setLocation(4, 343, 0);
   	self.rightHeroList:setListCell(Lua_KunXuHolyLandHeroItem, 108, 128, 1);

	self.btnConfirm:addClickFuntion(self, self.hide);
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLineupWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地布阵界面
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地战斗阵容准备界面
end

function Lua_KunXuHolyLandFightFailWindow:dispose()
	Lua_MsgUtil.callFunc("UPDATE_KUNXU_MODEL_MOVE");
	if self.leftHeroList ~= nil then
		self.leftHeroList:dispose();
		self.leftHeroList = nil;
	end
	if self.rightHeroList ~= nil then
		self.rightHeroList:dispose();
		self.rightHeroList = nil;
	end
	
	self:superCall("dispose");
end

function Lua_KunXuHolyLandFightFailWindow:showWin(param)
	self:superCall("showWin", param);

	local fightInfo = param.fight_info;
	for i = 1, #fightInfo do
		self.recordId = tonumber(fightInfo[i].record_id)
		if DataCenter.funcPathUtil:haveFightRecordFuncPath(self.recordId) then
			break
		end
	end
	DataCenter.fightData.curShowResultRecordId = self.recordId;

	self.levelId = param.stage_id;
	self.levelNameTxt.text = LanUtil.formateStr(440043, self.levelId % 100);
	self:updateFuncIcons();
	self:showFightResult();
end

function Lua_KunXuHolyLandFightFailWindow:showFightResult()
	local fightInfo = self.showData.fight_info;
	self:showResult(fightInfo[1].result == 1, fightInfo[2].result == 1);
	self:updateHeroList(fightInfo);
end

function Lua_KunXuHolyLandFightFailWindow:updateHeroList(fightInfo)
	local heroInfo = {};
	local info = fightInfo[1].hurt_collect.hurt_collect_list[1].attacker_hurt_collect;
	for i = 1, #info do
		if info[i].type ==  0 then -- 英雄
			heroInfo[#heroInfo + 1] = info[i];
		end
	end
	self.leftHeroList.canDrag = #heroInfo > 5;
	self.leftHeroList:setArrayData(heroInfo);

	heroInfo = {};
	info = fightInfo[2].hurt_collect.hurt_collect_list[1].attacker_hurt_collect;
	for i = 1, #info do
		if info[i].type ==  0 then -- 英雄
			heroInfo[#heroInfo + 1] = info[i];
		end
	end
	self.rightHeroList.canDrag = #heroInfo > 5;
	self.rightHeroList:setArrayData(heroInfo);
end

function Lua_KunXuHolyLandFightFailWindow:showResult(isLeftWin, isRightWin)
	if isLeftWin then
		self.leftResultSp:setAltas("fight_atlas_2", "xui_zd_word_14");
	else
		self.leftResultSp:setAltas("fight_atlas_2", "xui_zd_word_15");
	end

	if isRightWin then
		self.rightResultSp:setAltas("fight_atlas_2", "xui_zd_word_14");
	else
		self.rightResultSp:setAltas("fight_atlas_2", "xui_zd_word_15");
	end
end

function Lua_KunXuHolyLandFightFailWindow:onRemove()
	self:stopTimer();
	DataCenter.popupWinManager:removeDataByName(self.windowName);
	local fightInfo = self.showData.fight_info;
	for i = 1, #fightInfo do
		DataCenter.fightData:removeFightResult(fightInfo[i].record_id);
 		DataCenter.fightData:removeFight(fightInfo[i].record_id);
	end
end

function Lua_KunXuHolyLandFightFailWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1070, true, false);
end

-- 改位置
function Lua_KunXuHolyLandFightFailWindow:updateFuncIcons()
	local configData = Lua_FightTemplateConfigData.getConfigData(self.templateId);
	local list = configData.failOpenIcons;
	if list == nil or #list <= 0 then
		self:removeFuncIcons();
	else
		if self.iconsList == nil then
			self.iconsList = Array();
		end
		local len = self.iconsList:getSize();
		local num = #list - len;

		while (num > 0) do
			item = Lua_IconSkipItem.new(self.content);
			self.iconsList:add(item);
			num = num - 1;
		end

		while (num < 0) do
			item = self.iconsList:remove(1);
			item:dispose();
			num = num + 1;
		end

		len = self.iconsList:getSize();
		local space = 140;
		local w;
		local posX;
		local posY;
		for i = 1, len do
			item = self.iconsList[i];
			item:setClick(self, self.onIconSkip);
			item:setData(list[i]);

			w = -(space * len) / 2 + space / 2;
			posX = ((i - 1) % len) * space + w;
			posY = -400 + Mathf.Floor((i - 1) / len) * space -1;
			item:setLocation(posX, posY, 0);
		end
	end
end

function Lua_KunXuHolyLandFightFailWindow:onBtnHurtClick(go)
	if self.showData == nil then
		return;
	end
	self:onCancelTimer();
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandHurtWindow", Lua_WinParam.ACTION_OPEN, self.showData.fight_info);
end



















-- --------------------------描述Vo----------------------
-- Lua_KunXuHolyLandFightFailDescItem = class("Lua_KunXuHolyLandFightFailDescItem", Lua_DisplayObject);
-- function Lua_KunXuHolyLandFightFailDescItem:ctor(p)
--     self:superCall("ctor", p);
-- end

-- function Lua_KunXuHolyLandFightFailDescItem:buildShowItem()
-- 	self:superCall("buildShowItem");

-- 	self.backStarSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_kxsd_label_1", -89, -1, 56 * 0.54, 56 * 0.54);
-- 	self.descTxt = UICreate.createLabel(self.content, "", -10, 0, 100, 36, 26);
-- 	self.descTxt.horizontalOverflowValue = 1;
-- 	self.descTxt.alignmentValue = 3;
-- 	self.descTxt.effectStyle = 2;
-- 	self.descTxt.effectColorStr = Lua_ColorDefine.transColorStr("100E0B");
-- 	self.descTxt:setEffectDistance(2, 2);
-- end

-- function Lua_KunXuHolyLandFightFailDescItem:setData(data, isMeet)
-- 	-- if data == nil then
-- 	-- 	return;
-- 	-- end

-- 	if isMeet then
-- 		if self.resultSp == nil then
-- 			self.resultSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_xhd_label_004", -89, -1, 60 * 0.54, 57 * 0.54);
-- 		end
-- 		self.resultSp:setEnable(true);
-- 		self.descTxt.colorStr = Lua_ColorDefine.transColorStr("37D652");
-- 	else
-- 		if self.resultSp ~= nil then
-- 			self.resultSp:setEnable(false);
-- 		end
-- 		self.descTxt.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
-- 	end

-- 	self.descTxt.text = data.desc;
-- end

-- function Lua_KunXuHolyLandFightFailDescItem:dispose()
-- 	if self.backStarSp ~= nil then
-- 		self.backStarSp:dispose();
-- 		self.backStarSp = nil;
-- 	end
-- 	if self.resultSp ~= nil then
-- 		self.resultSp:dispose();
-- 		self.resultSp = nil;
-- 	end
-- 	if self.descTxt ~= nil then
-- 		self.descTxt:dispose();
-- 		self.descTxt = nil;
-- 	end

-- 	self:superCall("dispose");
-- end