-- 昆墟圣地战斗胜利界面
checkRequire("Lua_KunXuHolyLandHeroItem");
checkRequire("Lua_FightResultBaseWindow");
Lua_KunXuHolyLandFightWinWindow = class("Lua_KunXuHolyLandFightWinWindow", Lua_FightResultBaseWindow);
function Lua_KunXuHolyLandFightWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_KunXuHolyLandFightWinWindow";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self.skinName = "KunXuHolyLandFightWinWindow_skin";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";
	
	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_KunXuHolyLandFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftHeroList = Lua_DragList.new(self.content, 567, 128, Lua_AxisDefine.Horizontal);
	self.leftHeroList:setRectAnchor(7);
	self.leftHeroList:setLocation(0, 493, 0);
   	self.leftHeroList:setListCell(Lua_KunXuHolyLandHeroItem, 108, 128, 1);

   	self.rightHeroList = Lua_DragList.new(self.content, 567, 128, Lua_AxisDefine.Horizontal);
   	self.rightHeroList:setRectAnchor(7);
	self.rightHeroList:setLocation(4, 343, 0);
   	self.rightHeroList:setListCell(Lua_KunXuHolyLandHeroItem, 108, 128, 1);

	self.btnConfirm:addClickFuntion(self, self.hide);
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandLineupWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地布阵界面
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地战斗阵容准备界面
end

function Lua_KunXuHolyLandFightWinWindow:dispose()
	Lua_MsgUtil.callFunc("UPDATE_KUNXU_MODEL_MOVE");
	if self.descList ~= nil then
		for k, v in pairs(self.descList) do
			v:dispose();
			v = nil;
		end
		self.descList = nil;
	end
	if self.leftHeroList ~= nil then
		self.leftHeroList:dispose();
		self.leftHeroList = nil;
	end
	if self.rightHeroList ~= nil then
		self.rightHeroList:dispose();
		self.rightHeroList = nil;
	end
	
	self:superCall("dispose");
end

function Lua_KunXuHolyLandFightWinWindow:hide()
	local obj = self.showData.item_list;
	if obj ~= nil and #obj > 0 then
		local tab = DataCenter.packData:getRewardDic(obj);
		local arr = DataCenter.packData:getRewardList(tab);
		Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, arr);
	end
	self:superCall("hide");
end

function Lua_KunXuHolyLandFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	local fightInfo = param.fight_info;
	for i = 1, #fightInfo do
		self.recordId = tonumber(fightInfo[i].record_id)
		if DataCenter.funcPathUtil:haveFightRecordFuncPath(self.recordId) then
			break
		end
	end
	DataCenter.fightData.curShowResultRecordId = self.recordId;

	self.levelId = param.stage_id;
	self:showDesc(param.star_cond);
	self:showFightResult();
end

function Lua_KunXuHolyLandFightWinWindow:showDesc(star_cond)
	if self.descList == nil then
		self.descList = {};
	end

	self.levelNameTxt.text = LanUtil.formateStr(440043, self.levelId % 100);
	local obj;
	local isMeetList = {false, false, false};
	for i = 1, #star_cond do
		obj = star_cond[i];
		isMeetList[tonumber(obj.key)] = tonumber(obj.value) == 1;
	end

	local item;
	local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.levelId);
	local _descList = levelInfo.starList;
	for i = 1, #_descList do
		item = self.descList[i];
		if item == nil then
			item = Lua_KunXuHolyLandFightWinDescItem.new(self.content);
			item:setRectAnchor(7);
			self.descList[i] = item;
		end
		item:setLocation(-34, 705 - 48 * (i - 1));
		item:setData(_descList[i], isMeetList[i]);
	end
end

function Lua_KunXuHolyLandFightWinWindow:showFightResult()
	local fightInfo = self.showData.fight_info;
	self:showResult(fightInfo[1].result == 1, fightInfo[2].result == 1);
	self:updateHeroList(fightInfo);
end

function Lua_KunXuHolyLandFightWinWindow:updateHeroList(fightInfo)
	local heroInfo = {};
	local info = fightInfo[1].hurt_collect.hurt_collect_list[1].attacker_hurt_collect;
	for i = 1, #info do
		if info[i].type ==  0 then -- 英雄
			heroInfo[#heroInfo + 1] = info[i];
		end
	end
	self.leftHeroList.canDrag = #heroInfo > 5;
	self.leftHeroList:setArrayData(heroInfo);

	heroInfo = {};
	info = fightInfo[2].hurt_collect.hurt_collect_list[1].attacker_hurt_collect;
	for i = 1, #info do
		if info[i].type ==  0 then -- 英雄
			heroInfo[#heroInfo + 1] = info[i];
		end
	end
	self.rightHeroList.canDrag = #heroInfo > 5;
	self.rightHeroList:setArrayData(heroInfo);
end

function Lua_KunXuHolyLandFightWinWindow:showResult(isLeftWin, isRightWin)
	if isLeftWin then
		self.leftResultSp:setAltas("fight_atlas_2", "xui_zd_word_14");
	else
		self.leftResultSp:setAltas("fight_atlas_2", "xui_zd_word_15");
	end

	if isRightWin then
		self.rightResultSp:setAltas("fight_atlas_2", "xui_zd_word_14");
	else
		self.rightResultSp:setAltas("fight_atlas_2", "xui_zd_word_15");
	end
end

function Lua_KunXuHolyLandFightWinWindow:onRemove()
	self:stopTimer();
	DataCenter.popupWinManager:removeDataByName(self.windowName);
	local fightInfo = self.showData.fight_info;
	for i = 1, #fightInfo do
		DataCenter.fightData:removeFightResult(fightInfo[i].record_id);
 		DataCenter.fightData:removeFight(fightInfo[i].record_id);
	end
end

function Lua_KunXuHolyLandFightWinWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1070, true, false);
end

function Lua_KunXuHolyLandFightWinWindow:onBtnHurtClick(go)
	if self.showData == nil then
		return;
	end
	self:onCancelTimer();
	Lua_WindowUtil.openWin("Lua_KunXuHolyLandHurtWindow", Lua_WinParam.ACTION_OPEN, self.showData.fight_info);
end





















--------------------------描述Vo----------------------
Lua_KunXuHolyLandFightWinDescItem = class("Lua_KunXuHolyLandFightWinDescItem", Lua_DisplayObject);
function Lua_KunXuHolyLandFightWinDescItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_KunXuHolyLandFightWinDescItem:buildShowItem()
	self:superCall("buildShowItem");

	self.resultSp = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_label_06_1", -89, -1, 36, 35);
	self.descTxt = UICreate.createLabel(self.content, "", 4, 0, 100, 36, 28);
	self.descTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.descTxt.horizontalOverflowValue = 1;
	self.descTxt.alignmentValue = 3;
	self.descTxt.colorStr = Lua_ColorDefine.transColorStr("65be7a");
end

function Lua_KunXuHolyLandFightWinDescItem:setData(data, isMeet)
	local colorStr;
	if isMeet then
		colorStr = "65be7a";
		self.resultSp:setAltas("common_altas_1", "xui_common_label_06");
	else
		colorStr = "FFFFFF";
		self.resultSp:setAltas("common_altas_4", "xui_common_label_06_1");
	end

	self.descTxt.text = data.desc;
	self.descTxt.colorStr = Lua_ColorDefine.transColorStr(colorStr);
end

function Lua_KunXuHolyLandFightWinDescItem:dispose()
	if self.resultSp ~= nil then
		self.resultSp:dispose();
		self.resultSp = nil;
	end
	if self.descTxt ~= nil then
		self.descTxt:dispose();
		self.descTxt = nil;
	end

	self:superCall("dispose");
end