-- 昆墟圣地显示英雄Item
Lua_KunXuHolyLandHeroItem = class("Lua_KunXuHolyLandHeroItem", Lua_ListCell);
function Lua_KunXuHolyLandHeroItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_KunXuHolyLandHeroItem:buildShowItem()
    self:superCall("buildShowItem");

    self.heroItem = Lua_ItemIcon.new(self.content);
    self.heroItem:setRectAnchor(1);
    self.heroItem:setLocation(0, -54, 0);
    self.heroItem:setScale(0.86, 0.86);

    self.hpBar = UICreate.createProgressBar(self.content, "common_altas_1", "xui_common_tipsprogress_002_b", "common_altas_1", "xui_common_tipsprogress_002_f", 2, -62, 100, 10);
    self.hpBar.anchorValue = 1;
    self.hpBar:setLocation(2, -117, 0);
    self.hpBar:setScale(0.9, 0.9);
	self.hpBar:setBarOffset(2, 2);
	self.hpBar:setMaxValue(1);
	self.hpBar:setValue(0);
end

function Lua_KunXuHolyLandHeroItem:dispose()
    if self.heroItem ~= nil then
        self.heroItem:dispose();
        self.heroItem = nil;
    end
    if self.hpBar ~= nil then
        self.hpBar:dispose();
        self.hpBar = nil;
    end
    if self.deathSp ~= nil then
        self.deathSp:dispose();
        self.deathSp = nil;
    end

    self:superCall("dispose");
end

function Lua_KunXuHolyLandHeroItem:setData(data)
    if data == nil then
        return
    end

    local heroVo = Lua_HeroVo.new(data.sort_id);
    heroVo.level = data.level;
    heroVo.quality = data.quality;
    heroVo.quality_star = data.quality_star;
    heroVo.clothesId = data.clothes_id;
    self.heroItem:setData(heroVo);
    self.hpBar:setMaxValue(data.max_health);
    self.hpBar:setValue(data.health);

    local isDeath = data.health == 0;
    if isDeath then
        if self.deathSp == nil then
            self.deathSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_kxsd_label_6", 0, 0, 89, 39);
        end
        self.deathSp:setEnable(true);
    else
        if self.deathSp ~= nil then
            self.deathSp:setEnable(false);
        end
    end
    self.heroItem:setGray(isDeath);
end