--星魂试炼 战斗胜利结算Window
checkRequire("Lua_FightResultBaseWindow");
Lua_StarTrialFightWinWindow = class("Lua_StarTrialFightWinWindow", Lua_FightResultBaseWindow);
function Lua_StarTrialFightWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_StarTrialFightWinWindow";
	self.skinName = "StarTrialFightWinWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";

	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_StarTrialFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.condItemArr = Array();

	self.hurtBtn.anchorValue = 7;
	self.hurtBtn:setLocation(277, 73);
	self.backBtn:setStyle(7);

	self.backBtn:addClickFuntion(self, self.onBackBtnClick)
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_StarTrialFightWinWindow:dispose()
	if self.condItemArr ~= nil then
		self.condItemArr:dispose();
		self.condItemArr = nil;
	end
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_StarTrialFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	if self.closeText ~= nil then
		self.closeText.anchorValue = 7;
		self.closeText:setLocation(0, 90);
	end
	self:updateRewards(param.item_list);
	self:updateStarCond(param.star_cond);
	self:updateStarInfo(param.total_star);
end

function Lua_StarTrialFightWinWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	local stageVo = DataCenter.starTrialUitl:getStageVo(tonumber(self.showData.stage_id));
	if stageVo.brforeFightState == 2 then
		self.firstRewardTxt:setEnable(true);
	else
		if self.rewardList == nil then
			self.rewardList = Lua_ItemIconList.new(self.content);
			self.rewardList.canClick = true;
			self.rewardList:setSiblingIndex(7);
			self.rewardList:setLocation(0, -375, 0);
		end
		self.rewardList:setArrayData(arr);
		self.firstRewardTxt:setEnable(false);
	end
end

function Lua_StarTrialFightWinWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_StarTrialFightWinWindow:updateStarCond(starCond)
	local stageVo = DataCenter.starTrialUitl:getStageVo(tonumber(self.showData.stage_id));
	local arrLen = self.condItemArr:getSize();
	local dataLen = stageVo.starCondArr:getSize();
	local maxLen = arrLen > dataLen and arrLen or dataLen;
	local item;
	for i = 1, maxLen do
		item = self.condItemArr[i];
		if i > dataLen then
			item:setEnable(false);
		else
			if item == nil then
				item = Lua_StarTrialFightStarCondItem.new(self.content);
				self.condItemArr:add(item);
			end
			item:setEnable(true);
			item:setLocation(40, -80 - (i - 1) * 50, 0);
			item:setData(stageVo.starCondArr[i]);
		end
	end
	for k, v in ipairs(starCond) do
		self.condItemArr[tonumber(tostring(v.key))]:updateShow(tonumber(tostring(v.value)) == 1);
	end
end

function Lua_StarTrialFightWinWindow:updateStarInfo(totalStar)
	local vo = DataCenter.funcPathUtil:getFuncPathVo(1040);
	if vo and not vo.openState then -- 星河试炼活动未开启隐藏收集提示
		self.tipsTxt.text = nil;
		return;
	else
		-- 星河试炼活动结束隐藏收集提示
		local time = DataCenter.starRiverTrialData.close_tick - DataCenter.roleData.serverTime;
		if time <= 0 then
			self.tipsTxt.text = nil;
			return;
		end
	end

	local rewardVoList = DataCenter.starRiverTrialData.rewardVoList;
	table.sort(rewardVoList, function(a, b) return a.id < b.id end);
	local needComplete;
	for i = 1, #rewardVoList do
		if totalStar < rewardVoList[i].star_amount then
			needComplete = rewardVoList[i].star_amount;
			break;
		end
	end
	needComplete = needComplete or rewardVoList[#rewardVoList].star_amount;
	self.tipsTxt.text = LanUtil.formateStr(201629, totalStar, needComplete);
end

function Lua_StarTrialFightWinWindow:onBackBtnClick(go)
	DataCenter.funcPathUtil:gotoFunction(1041, true, false)
end





--------------------------------------------------





Lua_StarTrialFightStarCondItem = class("Lua_StarTrialFightStarCondItem", Lua_DisplayObject);
function Lua_StarTrialFightStarCondItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_StarTrialFightStarCondItem:buildShowItem()
	self:superCall("buildShowItem");
    
    self.starIcon = UICreate.createUIAtlasImage(self.content, "", "", -160, 0, 0, 0);

    self.desText = UICreate.createLabel(self.content, nil, -140, 0, 100, 40, 28);
    self.desText.pivotValue = 3;
    self.desText.alignmentValue = 3;
    self.desText.fontName = Lua_MyUISettings.huakangFontName;
    self.desText.horizontalOverflowValue = 1;
end

function Lua_StarTrialFightStarCondItem:dispose()
	self:superCall("dispose");
end

function Lua_StarTrialFightStarCondItem:setData(data)
	self.desText.text = data.desc;
end

function Lua_StarTrialFightStarCondItem:updateShow(val)
	if val == true then
		self.starIcon:setAltas("common_altas_1", "xui_common_label_06");
		self.desText.colorStr = Lua_ColorDefine.transColorStr("65BE7A");
	else
		self.starIcon:setAltas("common_altas_4", "xui_common_label_06_1");
		self.desText.colorStr = Lua_ColorDefine.transColorStr("CCCDCC");
	end
end
