-- 试炼副本战斗胜利界面
checkRequire("Lua_FightResultBaseWindow");
Lua_TrialFightWinWindow = class("Lua_TrialFightWinWindow", Lua_FightResultBaseWindow);
function Lua_TrialFightWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TrialFightWinWindow";
	self.skinName = "TrialFightResultWindow_skin";
	self.winBgPath = "/images/fight/xui_zd_bg_1.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self:addPreLoadRes("/effects/uiEffects/ui_zdjs_sl_01", Lua_LoadFileType.UNITY3D);
	self.openSound = "fight_win_01";
	
	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_TrialFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
	self.btnConfirm:addClickFuntion(self, self.hide);
end

function Lua_TrialFightWinWindow:dispose()
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_TrialFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	self:updateShowInfo();
	self:updateRewards(param.item_list);
end

function Lua_TrialFightWinWindow:updateShowInfo()
	local trialInfo = DataCenter.TrialData:getTrialEachById(self.showData.stage_id);
	local trialConstInfo = DataCenter.TrialData:getTrialTypeById(trialInfo.script_type);
	self.nameText.text = LanUtil.formateStr(10055, trialConstInfo.name, trialInfo.name);
end

function Lua_TrialFightWinWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardBg:SetDimensions(720, 266);
			self.rewardList = Lua_DragList.new(self.content, 556, 240, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 160, 4);
		else
			self.rewardBg:SetDimensions(720, 176);
			self.rewardList = Lua_DragList.new(self.content, len * 124 + (len - 1) * 20, 160, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 124, 160, 4);
		end
		self.rewardList:setCellSpacing(20, 0);
		-- self.rewardList:setRectAnchor(7);
		self.rewardList:setRectPivot(1)
		self.rewardList:setLocation(0, -208, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;
end

function Lua_TrialFightWinWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_TrialFightWinWindow:onBtnBackClick(go)
	local trialInfo = DataCenter.TrialData:getTrialEachById(self.showData.stage_id);
	DataCenter.TrialData.fightToShowType = trialInfo.script_type;
	DataCenter.funcPathUtil:gotoFunction(1011, true, false)
end